/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#ifndef _SDXSERVICE_PROG_NLKP_H_
#define _SDXSERVICE_PROG_NLKP_H_

#define NLK_PROTO													31
#define NLK_GROUP													0x23
#define NLK_DATA_MAX_LENGTH											2048
// DATA_MAX_LENGTH + HEADER
#define NLK_MSG_MAX_PAYLOAD											2060




#define NLK_PROTOCOL_VERSION										0x01

//--- TTY --------------------------------------------------------------
#define NLK_TTY_DRIVER_VERSION										"1.0.4.0"

#define NLK_TTY_MAJOR												222
#define NLK_TTY_MAX													256

#define NLK_DEVICE_TYPE_TTY											0x01

#define NLK_TTY_CMD_OPEN											0x0001
#define NLK_TTY_CMD_CLOSE											0x0002
#define NLK_TTY_CMD_SET_DLL_DLM										0x0003
#define NLK_TTY_CMD_SET_LCR											0x0004
#define NLK_TTY_CMD_SET_FIFO_CTRL									0x0005
#define NLK_TTY_CMD_SET_MCR											0x0006
#define NLK_TTY_CMD_SET_EVENT_CTRL									0x0007
#define NLK_TTY_CMD_GET_MSR											0x0008
#define NLK_TTY_CMD_GET_MODE_1										0x0009
#define NLK_TTY_CMD_SET_MODE_1										0x000a
#define NLK_TTY_CMD_GET_MODE_2										0x000b
#define NLK_TTY_CMD_SET_MODE_2										0x000c
#define NLK_TTY_CMD_GET_ON_CHIP_HARDWARE_FLOW_CTRL					0x000d
#define NLK_TTY_CMD_SET_ON_CHIP_HARDWARE_FLOW_CTRL					0x000e
#define NLK_TTY_CMD_GET_TX_CURRENT_CREDIT							0x000f
#define NLK_TTY_CMD_GET_TX_FIFO_DATA_CNT							0x0010
#define NLK_TTY_CMD_GET_TX_TRIGGER_LEVEL							0x0011
#define NLK_TTY_CMD_SET_TX_TRIGGER_LEVEL							0x0012
#define NLK_TTY_CMD_GET_RX_TRIGGER_LEVEL							0x0013
#define NLK_TTY_CMD_SET_RX_TRIGGER_LEVEL							0x0014
#define NLK_TTY_RESPONSE_OPEN										0x8001
#define NLK_TTY_RESPONSE_CLOSE										0x8002
#define NLK_TTY_RESPONSE_SET_DLL_DLM								0x8003
#define NLK_TTY_RESPONSE_SET_LCR									0x8004
#define NLK_TTY_RESPONSE_SET_FIFO_CTRL								0x8005
#define NLK_TTY_RESPONSE_SET_MCR									0x8006
#define NLK_TTY_RESPONSE_SET_EVENT_CTRL								0x8007
#define NLK_TTY_RESPONSE_GET_MSR									0x8008
#define NLK_TTY_RESPONSE_GET_MODE_1									0x8009
#define NLK_TTY_RESPONSE_SET_MODE_1									0x800a
#define NLK_TTY_RESPONSE_GET_MODE_2									0x800b
#define NLK_TTY_RESPONSE_SET_MODE_2									0x800c
#define NLK_TTY_RESPONSE_GET_ON_CHIP_HARDWARE_FLOW_CTRL				0x800d
#define NLK_TTY_RESPONSE_SET_ON_CHIP_HARDWARE_FLOW_CTRL				0x800e
#define NLK_TTY_RESPONSE_GET_TX_CURRENT_CREDIT						0x800f
#define NLK_TTY_RESPONSE_GET_TX_FIFO_DATA_CNT						0x8010
#define NLK_TTY_RESPONSE_GET_TX_TRIGGER_LEVEL						0x8011
#define NLK_TTY_RESPONSE_SET_TX_TRIGGER_LEVEL						0x8012
#define NLK_TTY_RESPONSE_GET_RX_TRIGGER_LEVEL						0x8013
#define NLK_TTY_RESPONSE_SET_RX_TRIGGER_LEVEL						0x8014
#define NLK_TTY_EVENT_MSR											0x1001
#define NLK_TTY_EVENT_LSR											0x1002
#define NLK_TTY_EVENT_DATA_SERVICE_TO_KERNEL						0x1004
#define NLK_TTY_DATA_KERNEL_TO_SERVICE								0x2001
#define NLK_TTY_DATA_SERVICE_TO_KERNEL								0x2002
// Event value define
// MSR
#define NLK_TTY_EVENT_MSR_CTS										0x01
#define NLK_TTY_EVENT_MSR_DSR										0x02
#define NLK_TTY_EVENT_MSR_RI										0x04
#define NLK_TTY_EVENT_MSR_DCD										0x08
// LSR
#define NLK_TTY_EVENT_LSR_TX_TRIGGER								0x01
#define NLK_TTY_EVENT_LSR_RX_ERROR									0x02
#define NLK_TTY_EVENT_LSR_RX_OVER_FLOW								0x04
#define NLK_TTY_EVENT_LSR_TX_EMPTY									0x08


//----------------------------------------------------------------------


// IPC packet for service and kernel
typedef struct _NLK_HEADER
{
	unsigned char				Version;
	unsigned char				Reserved;
	unsigned char				DeviceType;
	unsigned char				MinorNumber;
	unsigned short				CmdResponseEventData;
	unsigned short				ResponseStatus;
	unsigned int				Length;

} NLK_HEADER, *PNLK_HEADER;



#define NLK_STATUS_SUCCESS							0x00
#define NLK_STATUS_FAILURE							0x01


#endif


