/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


int 
ser_data_tx(
	struct snxdp_ser_port *		sp
	)
{
	struct sdp_ser_port *		port = &sp->port;
	int							retval = 0;
	int							length = 0;
	PNLK_HEADER					h_ptr = NULL;


	do
	{
		if (port->opened == false)
		{
			printk("SDDVIRTUAL : (M:%d) %s, Port not opened.\n", port->line, __FUNCTION__);
			retval = -ENODEV;
			break;
		}

		if ((port->tx_data_length <= 0) || (port->tx_data_length > NLK_DATA_MAX_LENGTH))
		{
			printk("SDDVIRTUAL : (M:%d) %s, Invalid transmit data length(%d).\n", port->line, __FUNCTION__, port->tx_data_length);
			retval = -ENODEV;
			break;
		}


		memset(port->tx_data_msg, 0, NLK_MSG_MAX_PAYLOAD);
		h_ptr = (PNLK_HEADER)port->tx_data_msg;
		h_ptr->Version = NLK_PROTOCOL_VERSION;
		h_ptr->DeviceType = NLK_DEVICE_TYPE_TTY;
		h_ptr->MinorNumber = (unsigned char)port->line;
		h_ptr->CmdResponseEventData = NLK_TTY_DATA_KERNEL_TO_SERVICE;
		h_ptr->ResponseStatus = 0;
		h_ptr->Length = port->tx_data_length;
		length = sizeof(NLK_HEADER);
		// data
		memcpy(port->tx_data_msg + sizeof(NLK_HEADER), port->tx_data_buff, port->tx_data_length);
		length += port->tx_data_length;

		retval = snxdp_nlk_tx(port->tx_data_msg, length);
		if (retval < 0)
		{
			printk("SDDVIRTUAL : (M:%d) %s, NLK tx fail(retval:%d).\n", port->line, __FUNCTION__, retval);
			break;
		}

	} while (false);

	return retval;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


