/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#ifndef _SDDVIRTUAL_DRVR_SXXF_H_
#define _SDDVIRTUAL_DRVR_SXXF_H_


// sxx_list.c
void
SxxListInit(
	DLIST *						pListHead
	);

bool
SxxListEmpty(
	DLIST *						pListHead
	);

DLIST *
SxxListGetNext(
	DLIST *						pListHead
	);

DLIST *
SxxListGetPrev(
	DLIST *						pListHead
	);

void
SxxListRemoveEntry(
	DLIST *						pEntry
	);

void
SxxListInsertEntry(
	DLIST *						pEntry,
	DLIST *						pNewEntry
	);

void
SxxListInsertHead(
	DLIST *						pListHead,
	DLIST *						pEntry
	);

void
SxxListInsertTail(
	DLIST *						pListHead,
	DLIST *						pEntry
	);


// ser_main.c
void
snxdp_ser_handle_port(
	struct snxdp_ser_port *		sp
	);

int 
snxdp_ser_register_ports(
	struct sdp_ser_driver *		drv
	);

void 
snxdp_ser_unregister_ports(
	struct sdp_ser_driver *		drv
	);

void 
snxdp_ser_initiate_ports(
	struct sdp_ser_driver *		drv
	);

int 
snxdp_ser_register_driver(
	struct sdp_ser_driver *		drv
	);

void 
snxdp_ser_unregister_driver(
	struct sdp_ser_driver *		drv
	);


// ser_openclose.c
int 
ser_open(
	struct tty_struct *			tty,
	struct file *				filp
	);

int 
ser_close(
	struct tty_struct *			tty,
	struct file *				filp
	);


// ser_cmd.c
int 
ser_cmd_set_dll_dlm(
	struct snxdp_ser_port *		sp,
	unsigned char				dll,
	unsigned char				dlm
	);

int 
ser_cmd_set_lcr(
	struct snxdp_ser_port *		sp,
	unsigned char				lcr
	);

int 
ser_cmd_set_fifo_ctrl(
	struct snxdp_ser_port *		sp,
	unsigned char				fifo_ctrl
	);

int 
ser_cmd_set_mcr(
	struct snxdp_ser_port *		sp,
	unsigned char				mcr
	);

int 
ser_cmd_set_event_ctrl(
	struct snxdp_ser_port *		sp,
	unsigned char				event_ctrl
	);

int 
ser_cmd_get_msr(
	struct snxdp_ser_port *		sp
	);

int 
ser_cmd_set_on_chip_hw_flow_ctrl(
	struct snxdp_ser_port *		sp,
	unsigned char				on_chip_hw_flow_ctrl
	);

int 
ser_cmd_set_tx_trigger_level(
	struct snxdp_ser_port *		sp,
	unsigned char				tx_trigger_level
	);

int 
ser_cmd_set_rx_trigger_level(
	struct snxdp_ser_port *		sp,
	unsigned char				rx_trigger_level
	);


// ser_data.c
int 
ser_data_tx(
	struct snxdp_ser_port *		sp
	);


// nlk_main.c
int 
snxdp_nlk_tx(
	unsigned char *				data,
	int							data_length
	);

int 
snxdp_nlk_init(
	void
	);

void 
snxdp_nlk_exit(
	void
	);


#endif


