/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
SxxListInit(
	DLIST *						pListHead
	)
{
	pListHead->Flink = pListHead->Blink = pListHead;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
SxxListEmpty(
	DLIST *						pListHead
	)
{
	if (pListHead->Flink == pListHead)
	{
		return true;
	}
	else
	{
		return false;
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


DLIST *
SxxListGetNext(
	DLIST *						pListHead
	)
{
	return pListHead->Flink;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


DLIST *
SxxListGetPrev(
	DLIST *						pListHead
	)
{
	return pListHead->Blink;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
SxxListRemoveEntry(
	DLIST *						pEntry
	)
{
	DLIST *						_DlistMEntry = pEntry;


	_DlistMEntry->Blink->Flink = _DlistMEntry->Flink;
	_DlistMEntry->Flink->Blink = _DlistMEntry->Blink;
	_DlistMEntry->Flink = _DlistMEntry->Blink = _DlistMEntry;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
SxxListInsertEntry(
	DLIST *						pEntry,
	DLIST *						pNewEntry
	)
{
	DLIST *						_DlistMEntry = pEntry;
	DLIST *						_DlistMNewEntry = pNewEntry;


	_DlistMNewEntry->Flink = _DlistMEntry->Flink;
	_DlistMNewEntry->Blink = _DlistMEntry;
	_DlistMEntry->Flink->Blink = _DlistMNewEntry;
	_DlistMEntry->Flink = _DlistMNewEntry;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
SxxListInsertHead(
	DLIST *						pListHead,
	DLIST *						pEntry
	)
{
	SxxListInsertEntry(pListHead, pEntry);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
SxxListInsertTail(
	DLIST *						pListHead,
	DLIST *						pEntry
	)
{
	SxxListInsertEntry(pListHead->Blink, pEntry);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


