/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Morris Ku
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Morris Ku
 ***********************************************************************/

#define 	STATUS_FAILURE								-1 
#define 	STATUS_SUCCESS								 0

#define 	STATUS_FUNCTION_UNSUPPORT					0x0001
#define 	STATUS_LENGTH_INVALID						0x0002
#define 	STATUS_DATA_INVALID							0x0003
#define 	STATUS_CONTROLLER_VERSION_UNSUPPORT			0x0004

#define 	STATUS_OBJECT_NOT_FOUND						0x0010
#define 	STATUS_BANK_NOT_FOUND						0x0011
#define 	STATUS_PORT_NOT_FOUND						0x0012
#define 	STATUS_WRONG_TCP_PORT_NUMBER				0x0013

#define 	STATUS_TX_CMD_FAIL							0x0020
#define 	STATUS_RX_RESPONSE_TIMEOUT					0x0021
#define 	STATUS_RX_RESPONSE_DATA_FORMAT_INVALID		0x0022
#define 	STATUS_RX_RESPONSE_WITH_NO_DATA				0x0023

#define 	STATUS_SERVICE_NOT_CONNECT					0x0050
#define		STATUS_CONNECT_FAIL							0x0051

#define 	STATUS_NO_INPUT_IO							0x0070
#define 	STATUS_NO_OUTPUT_IO							0x0071
#define 	STATUS_SUPPORT_WHOLE_BANK_INPUT_OR_OUTPUT	0x0072
#define 	STATUS_UNSUPPORT_INPUT_CAPABILITY			0x0073
#define 	STATUS_UNSUPPORT_OUTPUT_CAPABILITY			0x0074
#define 	STATUS_DIRECTION_CAPABILITY_UNKNOW			0x0075

#define 	SIO_STATUS_UNSUPPORT_GAIN_CTRL_FOR_ALL_PORT					0x0080
#define 	SIO_STATUS_UNSUPPORT_GAIN_CTRL_FOR_SPECIFIC_PORT			0x0081
#define 	SIO_STATUS_UNSUPPORT_FIFO									0x0082
#define 	SIO_STATUS_WRONG_DEVICE_TYPE								0x0084

int	dio_set_io_state(unsigned char * pMac,int DibChlNumber,int BankIndex, int IoIndex, unsigned char state);
int sio_get_connection_status(unsigned char * pMac);
int sio_init(unsigned char * Mac, int TcpPort);
int sio_free(unsigned char * Mac);
int dio_get_info(unsigned char * Mac, int DibChlNumber, PDIO_INFO pDioInfo);
int	dio_get_bank_state(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * BankState); 
int	dio_set_bank_state(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int BankState);
int	dio_get_bank_input_invert(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * BankInputInvert);
int	dio_set_bank_input_invert(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int BankInputInvert);  
int	dio_get_bank_direction(unsigned char * Mac,int DibChlNumber,int BankIndex, unsigned int * BankDirection); 
int	dio_set_bank_direction(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int BankDirection); 
int	dio_get_bank_input_event_mode(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned char * BankInputEventMode); 
int	dio_set_bank_input_event_mode(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned char BankInputEventMode);  
int	dio_get_bank_sampling_clock(unsigned char * Mac,int DibChlNumber, int BankIndex,unsigned char * BankSamplingClock); 
int	dio_get_bank_output_pin_config(unsigned char * Mac,int DibChlNumber, int BankIndex,unsigned char * BankOutputPinConfig); 
int	dio_set_bank_sampling_clock(unsigned char * Mac ,int DibChlNumber, int BankIndex ,unsigned char BankSamplingClock);
int	dio_set_bank_output_pin_config(unsigned char * Mac ,int DibChlNumber, int BankIndex , unsigned char BankOutputPinConfig); 

void (*callback)(unsigned char * pMac,int DibChlNumber, int BankIndex, unsigned int InputDelta, unsigned int InputValue);
void register_function(void (*in_main_func)(unsigned char * pMac,int DibChlNumber, int BankIndex, unsigned int InputDelta , unsigned int InputValue));
int dio_set_bank_event_callback(unsigned char * Mac,int DibChlNumber, int BankIndex, void (*callback)(unsigned char * pMac,int DibChlNumber, int BankIndex, unsigned int InputDelta,unsigned int InputValue));

void (*iocallback)(unsigned char * pMac,int DibChlNumber, int BankIndex, int IoIndex, unsigned char InputDelta, unsigned char InputValue);
void io_register_function(void (*io_main_func)(unsigned char * pMac,int DibChlNumber, int BankIndex, int IoIndex, unsigned char InputDelta , unsigned char InputValue));
int dio_set_io_event_callback(unsigned char * Mac,int DibChlNumber, int BankIndex, int IoIndex, void (*iocallback)(unsigned char * pMac,int DibChlNumber, int BankIndex, int IoIndex, unsigned char InputDelta,unsigned char InputValue));

int	dio_get_bank_output_initial_value(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * InitialValue); 
int	dio_set_bank_output_initial_value(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int  InitialValue); 
int	dio_get_bank_output_safe_value(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * SafeValue); 
int	dio_set_bank_output_safe_value(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int  SafeValue); 
int	dio_get_output_safe_value_timer(unsigned char * Mac,int DibChlNumber,unsigned char * Setting , unsigned char * Seconds); 
int	dio_set_output_safe_value_timer(unsigned char * Mac,int DibChlNumber,unsigned char Setting , unsigned char Seconds);
int	dio_get_bank_input_latch_rising_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * LatchEdge); 
int	dio_set_bank_input_latch_rising_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int  LatchEdge); 
int	dio_get_bank_input_latch_falling_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * LatchEdge); 
int	dio_set_bank_input_latch_falling_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int  LatchEdge);
int	dio_set_bank_input_counter_reset(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int Value); 
int	dio_get_bank_input_counter_increment_rising_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * Value); 
int	dio_set_bank_input_counter_increment_rising_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int  Value); 
int	dio_get_bank_input_counter_increment_falling_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int * Value); 
int	dio_set_bank_input_counter_increment_falling_edge(unsigned char * Mac,int DibChlNumber,int BankIndex,unsigned int  Value);
int	dio_get_bank_io_input_counter_value(unsigned char * pMac,int DibChlNumber,int BankIndex,unsigned char BankIoIndex , unsigned int * Value);

int ai_get_ai_info(unsigned char * Mac, int DibChlNumber, PAI_INFO pAiInfo);
int ai_get_sample_enable(unsigned char * Mac, int DibChlNumber, unsigned char * SampleEnable);
int ai_set_sample_enable(unsigned char * Mac, int DibChlNumber, unsigned char SampleEnable);
int ai_get_data_enable(unsigned char * Mac, int DibChlNumber, unsigned char * DataEnable);
int ai_set_data_enable(unsigned char * Mac, int DibChlNumber, unsigned char DataEnable);
int ai_get_event_enable(unsigned char * Mac, int DibChlNumber, unsigned char * EventEnable);
int ai_set_event_enable(unsigned char * Mac, int DibChlNumber, unsigned char EventEnable);
int ai_get_ports_enable(unsigned char * Mac, int DibChlNumber, unsigned short * PortsEnable);
int ai_set_ports_enable(unsigned char * Mac, int DibChlNumber, unsigned short PortsEnable);
int ai_get_all_gain_control(unsigned char * Mac, int DibChlNumber, unsigned char * GainControl);
int ai_set_all_gain_control(unsigned char * Mac, int DibChlNumber, unsigned char GainControl);
int ai_get_port_sample_rate_divider(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned int * SampleRateDivider);
int ai_set_port_sample_rate_divider(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned int SampleRateDivider);
int ai_get_port_gain_control(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char * GainControl);
int ai_set_port_gain_control(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char GainControl);
int ai_get_port_logging_mode(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char * LoggingMode);
int ai_set_port_logging_mode(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char LoggingMode);
int ai_get_port_trigger_mode(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char * TriggerMode);
int ai_set_port_trigger_mode(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char TriggerMode);
int ai_get_port_upper_trigger_value(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned short * UpperTriggerValue);
int ai_set_port_upper_trigger_value(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned short UpperTriggerValue);
int ai_get_port_lower_trigger_value(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned short * LowerTriggerValue);
int ai_set_port_lower_trigger_value(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned short LowerTriggerValue);
int ai_get_port_fifo_trigger_value(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char * FifoTriggerValue);
int ai_set_port_fifo_trigger_value(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char FifoTriggerValue);

void (*AiEventTriggerCallBack)(unsigned char AiPort , unsigned char EventMode , unsigned short Value);
void ai_register_function(void (*AiEventTriggerMainFunc)(unsigned char AiPort , unsigned char EventMode , unsigned short Value));
int ai_set_event_callback(unsigned char * Mac,int DibChlNumber, void (*AiEventTriggerCallBack)(unsigned char AiPort , unsigned char EventMode , unsigned short Value));

void (*AiDataCallBack)(unsigned char AiPort,unsigned short Data);
void ai_data_register_function(void (*AiDataMainFunc)(unsigned char AiPort ,unsigned short Data));
int ai_set_data_callback(unsigned char * Mac,int DibChlNumber, void (*AiDataCallBack)(unsigned char AiPort, unsigned short Data));

int ao_get_ao_info(unsigned char * Mac, int DibChlNumber, PAO_INFO pAoInfo);
int ao_set_ports_enable(unsigned char * Mac, int DibChlNumber, unsigned short  PortsEnable);
int ao_get_port_gain_control(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char * PortGainCtrl);
int ao_set_port_gain_control(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned char PortGainCtrl);
int ao_set_port_update_rate_divider(unsigned char * Mac, int DibChlNumber, unsigned char PortIndex, unsigned int PortUpdateRateDivider);
int ao_set_data(unsigned char * pMac, int DibChlNumber, unsigned char PortIndex,unsigned short AoCode);

int ser_open(unsigned char * pMac, int DibChlNumber, PSER_STATE_INFO pStateInfo);
int ser_close(unsigned char * pMac, int DibChlNumber);
int ser_set_dll_dlm(unsigned char * pMac,int DibChlNumber, unsigned char DLL ,unsigned char DLM);
int ser_set_lcr(unsigned char * pMac, int DibChlNumber, unsigned char LCR);
int ser_set_fifo_ctrl(unsigned char * pMac, int DibChlNumber, unsigned char FIFO_CTRL);
int ser_set_mcr(unsigned char * pMac, int DibChlNumber, unsigned char MCR);
int ser_set_event_ctrl(unsigned char * pMac, int DibChlNumber, unsigned char EVENT_CTRL);
int ser_set_power_io(unsigned char * pMac, int DibChlNumber, unsigned char MODE);
int ser_set_mode_ctrl(unsigned char * pMac, int DibChlNumber, unsigned char MODE);
int ser_get_msr(unsigned char * pMac, int DibChlNumber, unsigned char * MSR);
int ser_write(unsigned char * pMac, int DibChlNumber, unsigned char * Data, int DataLength);
int ser_setting(unsigned char * pMac, int DibChlNumber, unsigned char Baud, unsigned char DataBits, unsigned char Parity, unsigned char StopBit,unsigned char FlowControl);
int ser_get_on_chip_hw_flow_ctrl(unsigned char * pMac, int DibChlNumber, unsigned char * HwFlowCtrl);
int ser_set_on_chip_hw_flow_ctrl(unsigned char * pMac, int DibChlNumber, unsigned char  HwFlowCtrl);
int ser_get_tx_trigger_level(unsigned char * pMac, int DibChlNumber, unsigned char * TxTriggerLevel);
int ser_set_tx_trigger_level(unsigned char * pMac, int DibChlNumber, unsigned char  TxTriggerLevel);
int ser_get_rx_trigger_level(unsigned char * pMac, int DibChlNumber, unsigned char * RxTriggerLevel);
int ser_set_rx_trigger_level(unsigned char * pMac, int DibChlNumber, unsigned char  RxTriggerLevel);
int ser_set_break(unsigned char * pMac, int DibChlNumber, unsigned char state);

//MSR event
void (*SerSetMsrCallBack)(unsigned char * pMac, int DibChlNumber, unsigned char MsrEvent);
void ser_msr_event_register_function(void (*SerMsrEventMainFunc)(unsigned char * pMac, int DibChlNumber, unsigned char MsrEvent));
int ser_set_msr_event_callback(unsigned char * Mac,int DibChlNumber, void (*SerSetMsrCallBack)(unsigned char * pMac, int DibChlNumber, unsigned char MsrEvent));

//LSR event
void (*SerSetLsrCallBack)(unsigned char * Mac,int DibChlNumber, unsigned char LsrEvent,unsigned char CreditBit8, unsigned char Credit);
void ser_lsr_event_register_function(void (*SerLsrEventMainFunc)(unsigned char * Mac,int DibChlNumber, unsigned char LsrEvent,unsigned char CreditBit8, unsigned char Credit));
int ser_set_lsr_event_callback(unsigned char * Mac,int DibChlNumber, void (*SerSetLsrCallBack)(unsigned char * Mac,int DibChlNumber, unsigned char LsrEvent,unsigned char CreditBit8, unsigned char Credit));

//data event
void (*SerSetDataEventCallBack)(unsigned char * pMac, int DibChlNumber, unsigned char * Data , int DataLength);
void ser_data_event_register_function(void (*SerDataEventMainFunc)(unsigned char * pMac, int DibChlNumber, unsigned char * Data , int DataLength));
int ser_set_data_event_callback(unsigned char * Mac,int DibChlNumber, void (*SerSetDataEventCallBack)(unsigned char * pMac, int DibChlNumber, unsigned char * Data , int DataLength));

//data callback
void (*SerSetDataCallBack)(unsigned char * Data, int DataLength);
void ser_data_register_function(void (*SerDataMainFunc)(unsigned char * Data, int DataLength));
int ser_set_data_callback(unsigned char * Mac,int DibChlNumber, void (*SerSetDataCallBack)(unsigned char * Data, int DataLength));

int mai_get_info(unsigned char * pMac, int	DibChl, PMAI_INFO pMaiInfo);
int mai_set_sample_enable(unsigned char * pMac, int	DibChlNumber, unsigned char State); //0x00 -> disable, 0x01 -> enable
int mai_set_data_enable(unsigned char * pMac, int DibChlNumber, unsigned char State); //0x00 -> disable, 0x01 -> enable
int mai_set_event_enable(unsigned char * pMac, int DibChlNumber, unsigned char State); //0x00 -> disable, 0x01 -> enable
int mai_set_ports_enable(unsigned char * pMac, int DibChlNumber, unsigned short State);
int mai_get_ports_enable(unsigned char * pMac, int DibChlNumber, unsigned short  * State);

int mai_set_calibration_value(unsigned char * pMac, int	DibChlNumber, unsigned short value);
int mai_set_port_ai_mode(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char value);
int mai_set_port_trigger_mode(unsigned char * pMac, int	DibChlNumber, int PortChl, unsigned char mode);
int mai_set_port_upper_trigger_value(unsigned char * pMac, int DibChlNumber, int PortChl, double Value);
int mai_set_port_lower_trigger_value(unsigned char * pMac, int DibChlNumber, int PortChl, double Value);

int mai_set_type1_input_type(unsigned char * pMac, int	DibChlNumber, int PortChl, unsigned char type);
int mai_set_type1_input_select(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char  value);	
int mai_set_type1_pga_enable(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char value);
int mai_get_type1_pga_enable(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char * pValue);	
int mai_set_type1_gain(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char value);
int mai_get_type1_gain(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char *pValue);	

int mai_set_type0_input_type(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char type);
int mai_set_type0_input_select(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char  value);	
int mai_set_type0_pullup_resistor(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char value);
int mai_set_type0_gain(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char value);	
int mai_set_type0_filter(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned short value);
int mai_get_logging_mode(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char *pMode);
int mai_set_logging_mode(unsigned char * pMac, int DibChlNumber, int PortChl, unsigned char Mode);

//Mai event
void (*MaiEventCallBack)(unsigned char *pMac, int DibChlNumber, int PortChl, unsigned char Event, double EventValue);
void mai_event_register_function(void (*MaiEventMainFunc)(unsigned char *pMac, int DibChlNumber, int PortChl, unsigned char Event,double EventValue));
int mai_set_event_callback(unsigned char *Mac,int DibChlNumber, void (*MaiEventCallBack)(unsigned char *pMac, int DibChlNumber, int PortChl, unsigned char Event, double EventValue));

//mai data 
void (*MaiDataCallBack)(unsigned char *pMac, int DibChlNumber, int PortChl,double Data);
void mai_data_register_function(void (*MaiDataMainFunc)(unsigned char *pMac, int DibChlNumber, int PortChl ,double Data));
int mai_set_data_callback(unsigned char * Mac,int DibChlNumber, void (*MaiDataCallBack)(unsigned char *pMac, int DibChlNumber, int PortChl, double Data));
