/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSearchSDp(
	void
	)
{
	bool						bSuccess = false;
	bool						bReturn = false;
	PDP_LIST					pDpList = NULL;

	int							i = 0;
	int							j = 0;
	PSDP_DEVICE					pSDp = NULL;
	unsigned char				Password[256];
	unsigned int				PasswordLength = 0;


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}

		pDpList = (PDP_LIST)malloc(sizeof(DP_LIST));
		if (pDpList == NULL)
		{
			break;
		}
		memset(pDpList, 0, sizeof(DP_LIST));

		bReturn = LibMngSearchDp(pDpList);
		if (bReturn != true)
		{
			break;
		}


		SDpMainDelAllWithoutConnectedByHost();


		for (i = 0 ; i < pDpList->DpAmount; i++)
		{
			pSDp = SDpMainGetByMac(pDpList->DpInfo[i].Mac);
			if (pSDp != NULL)
			{
				//printf("INT (:%.2x:%.2x:%.2x), Search, is connected\n", pDpList->DpInfo[i].Mac[3], pDpList->DpInfo[i].Mac[4], pDpList->DpInfo[i].Mac[5]);
				continue;
			}

			bReturn = LibMngGetSpecificDpDetailInfo(pDpList->DpInfo[i].Mac, &pDpList->DpInfo[i]);
			if (bReturn != true)
			{
				//printf("INT (:%.2x:%.2x:%.2x), Search, get detail info fail\n", pDpList->DpInfo[i].Mac[3], pDpList->DpInfo[i].Mac[4], pDpList->DpInfo[i].Mac[5]);
				continue;
			}


			// debug
			/*
			for (j = 0; j < pDpList->DpInfo[i].Channels; j++)
			{
				if (pDpList->DpInfo[i].DibInfo[j].Type == DLLP_CHL_TYPE_UART)
				{
					printf(" -------------------------------\n");
					printf(" RS232Capability          : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.RS232Capability);
					printf(" RS422Capability          : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.RS422Capability);
					printf(" RS485Capability          : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.RS485Capability);
					printf(" AHDCCapability           : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.AHDCCapability);
					printf(" CSCapability             : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.CSCapability);
					printf(" RS422TerminationCtlCapability : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.RS422TerminationCtlCapability);
					printf(" RS485TerminationCtlCapability : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.RS485TerminationCtlCapability);
					printf(" RIPowerIOCapability      : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.RIPowerIOCapability);
					printf(" DCDPowerIOCapability     : x%02x\n", pDpList->DpInfo[i].DibInfo[j].SerInfo.DCDPowerIOCapability);
					printf(" -------------------------------\n");
				}

				if (pDpList->DpInfo[i].DibInfo[j].Type == DLLP_CHL_TYPE_MULTIFUNC_AI)
				{
					printf(" -------------------------------\n");
					printf(" MAI_Type                 : x%02x\n", pDpList->DpInfo[i].DibInfo[j].MaiInfo.MAI_Type);
					printf(" -------------------------------\n");
				}
			}
			*/


			bReturn = SDpMainAdd(&pDpList->DpInfo[i], false, Password, PasswordLength);
			if (bReturn != true)
			{
				//printf("INT (:%.2x:%.2x:%.2x), Search, add fail\n", pDpList->DpInfo[i].Mac[3], pDpList->DpInfo[i].Mac[4], pDpList->DpInfo[i].Mac[5]);
			}
		}

		bSuccess = true;

	} while (false);

	if (pDpList != NULL)
	{
		free(pDpList);
		pDpList = NULL;
	}

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSDpConnect(
	PSDP_DEVICE					pSDp,
	bool						PasswdEnable,
	char *						pPasswdData,
	int							PasswdDataLength
	)
{
	bool						bSuccess = false;
	PDP_INFO					pDpInfo = &pSDp->DpInfo;
	bool						bReturn = false;
	unsigned char				PasswdRequest = PasswdEnable?0x01:0x00;
	int							SioTcpPort = 0;
	int							CtuTcpPort = 0;
	int 						i = 0;


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}

		bReturn = LibMngConnect(pDpInfo->Mac, PasswdRequest, (unsigned char *)pPasswdData, PasswdDataLength, &SioTcpPort, &CtuTcpPort);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Connect, LibMngConnect fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}

		bReturn = LibMngGetSpecificDpDetailInfo(pDpInfo->Mac, pDpInfo);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Connect, LibMngGetSpecificDpDetailInfo fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}

		bReturn = LibMngSetDisconnectEventCallback(pDpInfo->Mac);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Connect, LibMngSetDisconnectEventCallback fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}

		//usleep(200 * 1000);

		bReturn = LibCtuConnect(pDpInfo->Mac);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Connect, LibCtuConnect fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}

		bReturn = LibSioConnect(pDpInfo->Mac, SioTcpPort);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Connect, LibSioConnect fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}


		memset(pSDp->Password, 0, sizeof(pSDp->Password));
		pSDp->PasswordLength = 0;
		if ((PasswdDataLength > 0) && (PasswdDataLength < 128))
		{
			memcpy(pSDp->Password, pPasswdData, PasswdDataLength);
			pSDp->PasswordLength = PasswdDataLength;
		}

		for (i = 0; i < pDpInfo->Channels; i++)
		{
			//printf("pSDp->DibArray[i].Info.Type:x%02x\n", pSDp->DibArray[i].Info.Type);
			if (pSDp->DibArray[i].Info.Type == DLLP_CHL_TYPE_UART)
			{
				//printf("INT (:%.2x:%.2x:%.2x), Connect, get SER info for opc\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			}
			if (pSDp->DibArray[i].Info.Type == DLLP_CHL_TYPE_DIO)
			{
				bReturn = LibDioGetInfo(pDpInfo->Mac, pSDp->DibArray[i].Info.ChlNumber, &pSDp->DibArray[i].Info.DioInfo);
				//printf("INT (:%.2x:%.2x:%.2x), Connect, get DIO info for opc, bReturn:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], bReturn?"TRUE":"FALSE");
			}
			if (pSDp->DibArray[i].Info.Type == DLLP_CHL_TYPE_MULTIFUNC_AI)
			{
				bReturn = LibMAiGetInfo(pDpInfo->Mac, pSDp->DibArray[i].Info.ChlNumber, &pSDp->DibArray[i].Info.MaiInfo);
				//printf("INT (:%.2x:%.2x:%.2x), Connect, get MAi info for opc, bReturn:%s, MAI_Type:x%02x\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], bReturn?"TRUE":"FALSE", pSDp->DibArray[i].Info.MaiInfo.MAI_Type);
			}
		}

		pSDp->IsConnectedByHost = true;

		OpcMngDelSDpForSearch(pSDp);
		OpcMngAddSDpForConnect(pSDp);

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSDpDisconnect(
	PSDP_DEVICE					pSDp
	)
{
	bool						bSuccess = false;
	PDP_INFO					pDpInfo = &pSDp->DpInfo;
	bool						bReturn = false;


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}


		OpcMngDelSDpForConnect(pSDp);


		bReturn = LibSioDisconnect(pDpInfo->Mac);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Disconnect, LibSioDisconnect fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			//break;
		}

		bReturn = LibCtuDisconnect(pDpInfo->Mac);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Disconnect, LibCtuDisconnect fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			//break;
		}

		usleep(200 * 1000);

		bReturn = LibMngDisconnect(pDpInfo->Mac);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Disconnect, LibMngDisconnect fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			//break;
		}

		bReturn = LibMngGetSpecificDpDetailInfo(pDpInfo->Mac, pDpInfo);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), Disconnect, LibMngGetSpecificDpDetailInfo fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			//break;
		}


		pSDp->IsConnectedByHost = false;


		OpcMngAddSDpForSearch(pSDp);

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSDpSetDeviceName(
	PSDP_DEVICE					pSDp,
	char *						pDeviceName
	)
{
	bool						bSuccess = false;
	PDP_INFO					pDpInfo = &pSDp->DpInfo;
	bool						bReturn = false;
	int							i = 0;


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}

		bReturn = LibCtuSetDeviceName(pDpInfo->Mac, (unsigned char *)pDeviceName);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), SetDeviceName, LibCtuSetDeviceName fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}


		pSDp->HasDeviceName = true;
		memset(pSDp->DeviceName, 0, sizeof(pSDp->DeviceName));
		memcpy(pSDp->DeviceName, pDeviceName, strlen(pDeviceName));

		OpcMngUpdateSDpDeviceName(pSDp);

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSDpSetDeviceMac(
	PSDP_DEVICE					pSDp,
	char *						pDeviceMac
	)
{
	bool						bSuccess = false;
	PDP_INFO					pDpInfo = &pSDp->DpInfo;
	bool						bReturn = false;


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}

		bReturn = LibCtuSetMac(pDpInfo->Mac, (unsigned char *)pDeviceMac);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), SetDeviceMac, LibCtuSetDeviceName fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}


		pSDp->IsConnectedByHost = false;

		OpcMngDelSDpForConnect(pSDp);

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSDpSetPassword(
	PSDP_DEVICE					pSDp,
	char *						pPasswdData,
	int							PasswdDataLength
	)
{
	bool						bSuccess = false;
	PDP_INFO					pDpInfo = &pSDp->DpInfo;
	bool						bReturn = false;
	unsigned char				Setting = 0x01;


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}

		bReturn = LibCtuSetPassword(pDpInfo->Mac, Setting, (unsigned char *)pPasswdData);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), SetPassword, LibCtuSetPassword fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}


		pDpInfo->PasswordEnable = Setting;
		memset(pSDp->Password, 0, sizeof(pSDp->Password));
		memcpy(pSDp->Password, pPasswdData, PasswdDataLength);
		pSDp->PasswordLength = PasswdDataLength;

		OpcMngUpdateSDpPassword(pSDp);

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
IntMngSDpClearPassword(
	PSDP_DEVICE					pSDp
	)
{
	bool						bSuccess = false;
	PDP_INFO					pDpInfo = &pSDp->DpInfo;
	bool						bReturn = false;
	unsigned char				Setting = 0x00;
	char						PasswdData[256] = {0};


	do
	{
		if (SDpServiceIsStartUp != true)
		{
			break;
		}

		bReturn = LibCtuSetPassword(pDpInfo->Mac, Setting, PasswdData);
		if (bReturn != true)
		{
			//printf("INT (:%.2x:%.2x:%.2x), ClearPassword, LibCtuSetPassword fail\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);
			break;
		}


		pDpInfo->PasswordEnable = Setting;
		memset(pSDp->Password, 0, sizeof(pSDp->Password));

		OpcMngUpdateSDpPassword(pSDp);

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
IntMngDisconnectEventCallback(
	unsigned char *				pMac
	)
{
	PSDP_DEVICE					pSDp = NULL;


	//printf("INT (:%.2x:%.2x:%.2x), ##### disconnect event #####\n", pMac[3], pMac[4], pMac[5]);

	do
	{
		pSDp = SDpMainGetByMac(pMac);
		if (pSDp == NULL)
		{
			break;
		}

		pSDp->IsConnectedByHost = false;
		OpcMngDelSDpForConnect(pSDp);

	} while (false);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


