/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuConnect(
	unsigned char *				pMac
	)
{
	int							nStatus = MNG_STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_connect(pMac);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_connect fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuDisconnect(
	unsigned char *				pMac
	)
{
	int							nStatus = MNG_STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_disconnect(pMac);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_disconnect fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuSetMac(
	unsigned char *				pMac,
	unsigned char *				pNewMac
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_set_mac(pMac, pNewMac);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_set_mac fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuSetDeviceName(
	unsigned char *				pMac,
	unsigned char *				pDeviceName
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_set_device_name(pMac, pDeviceName);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_set_device_name fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuSetPassword(
	unsigned char *				pMac,
	unsigned char 				PwdSetting,
	unsigned char *				pPwdData
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_set_passsword(pMac, PwdSetting, pPwdData);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_set_passsword fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuStoreUartSetting(
	unsigned char *				pMac
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_set_uart_setting(pMac);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_set_uart_setting fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibCtuStoreDioSetting(
	unsigned char *				pMac
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ctu_set_dio_setting(pMac);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB CTU (:%.2x:%.2x:%.2x), ctu_set_dio_setting fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


