/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetInfo(
	unsigned char *				pMac,
	int							DibChlNumber,
	PDIO_INFO 					pDioInfo
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_info(pMac, DibChlNumber, pDioInfo);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_info fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankState(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pBankState
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_state(pMac, DibChlNumber, BankIndex, pBankState);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_state fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankInputInvert(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pBankInputInvert
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_input_invert(pMac, DibChlNumber, BankIndex, pBankInputInvert);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_input_invert fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankDirection(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pBankDirection
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_direction(pMac, DibChlNumber, BankIndex, pBankDirection);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_direction fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankInputEventMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char *				pBankInputEventMode
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_input_event_mode(pMac, DibChlNumber, BankIndex, pBankInputEventMode);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_input_event_mode fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankState(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				BankState
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_state(pMac, DibChlNumber, BankIndex, BankState);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_state fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputInvert(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				BankInputInvert
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_invert(pMac, DibChlNumber, BankIndex, BankInputInvert);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_invert fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankDirection(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				BankDirection
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_direction(pMac, DibChlNumber, BankIndex, BankDirection);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_direction fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputEventMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char 				BankInputEventMode
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_event_mode(pMac, DibChlNumber, BankIndex, BankInputEventMode);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_event_mode fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankSamplingClock(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char *				pBankSamplingClock
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_sampling_clock(pMac, DibChlNumber, BankIndex, pBankSamplingClock);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_sampling_clock fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankOutputPinConfig(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char *				pBankOutputPinConfig
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_output_pin_config(pMac, DibChlNumber, BankIndex, pBankOutputPinConfig);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_output_pin_config fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankSamplingClock(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char 				BankSamplingClock
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_sampling_clock(pMac, DibChlNumber, BankIndex, BankSamplingClock);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_sampling_clock fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankOutputPinConfig(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char 				BankOutputPinConfig
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_output_pin_config(pMac, DibChlNumber, BankIndex, BankOutputPinConfig);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_output_pin_config fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankOutputInitialValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pInitialValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_output_initial_value(pMac, DibChlNumber, BankIndex, pInitialValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_output_initial_value fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankOutputInitialValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				InitialValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_output_initial_value(pMac, DibChlNumber, BankIndex, InitialValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_output_initial_value fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankOutputSafeValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pSafeValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_output_safe_value(pMac, DibChlNumber, BankIndex, pSafeValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_output_safe_value fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankOutputSafeValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				SafeValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_output_safe_value(pMac, DibChlNumber, BankIndex, SafeValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_output_safe_value fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetOutputSafeValueTimer(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pSetting,
	unsigned char *				pSeconds
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_output_safe_value_timer(pMac, DibChlNumber, pSetting, pSeconds);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_output_safe_value_timer fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetOutputSafeValueTimer(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Setting,
	unsigned char				Seconds
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_output_safe_value_timer(pMac, DibChlNumber, Setting, Seconds);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_output_safe_value_timer fail, Setting:%d, Seconds:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], Setting, Seconds, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankInputLatchRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pLatchEdge
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_input_latch_rising_edge(pMac, DibChlNumber, BankIndex, pLatchEdge);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_input_latch_rising_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputLatchRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				LatchEdge
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_latch_rising_edge(pMac, DibChlNumber, BankIndex, LatchEdge);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_latch_rising_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankInputLatchFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pLatchEdge
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_input_latch_falling_edge(pMac, DibChlNumber, BankIndex, pLatchEdge);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_input_latch_falling_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputLatchFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				LatchEdge
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_latch_falling_edge(pMac, DibChlNumber, BankIndex, LatchEdge);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_latch_falling_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputCounterReset(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_counter_reset(pMac, DibChlNumber, BankIndex, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_counter_reset fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankInputCounterIncrementRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_input_counter_increment_rising_edge(pMac, DibChlNumber, BankIndex, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_input_counter_increment_rising_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputCounterIncrementRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_counter_increment_rising_edge(pMac, DibChlNumber, BankIndex, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_counter_increment_rising_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankInputCounterIncrementFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_input_counter_increment_falling_edge(pMac, DibChlNumber, BankIndex, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_input_counter_increment_falling_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputCounterIncrementFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_set_bank_input_counter_increment_falling_edge(pMac, DibChlNumber, BankIndex, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_set_bank_input_counter_increment_falling_edge fail, BankIndex:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioGetBankIoInputCounterCounterValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char				BankIoIndex,
	unsigned int *				pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = dio_get_bank_io_input_counter_value(pMac, DibChlNumber, BankIndex, BankIoIndex, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x), dio_get_bank_io_input_counter_value fail, BankIndex:%d, Port:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], BankIndex, BankIoIndex, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibDioSetBankInputEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex
	)
{
	int							nStatus = MNG_STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		if (pMac == NULL)
		{
			break;
		}

		register_function(IntDioBankInputEventCallback);

		nStatus = dio_set_bank_event_callback(pMac, DibChlNumber, BankIndex, IntDioBankInputEventCallback);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB DIO (:%.2x:%.2x:%.2x),, dio_set_bank_event_callback fail, BankIndex:%d, code:x%02x\n",  pMac[3], pMac[4], pMac[5], BankIndex, nStatus);
			break;
		}
		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


