/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiGetInfo(
	unsigned char *				pMac,
	int							DibChlNumber,
	PMAI_INFO 					pMAiInfo
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_get_info(pMac, DibChlNumber, pMAiInfo);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_get_info fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetSampleEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_sample_enable(pMac, DibChlNumber, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_sample_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetDataEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_data_enable(pMac, DibChlNumber, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_data_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetEventEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_event_enable(pMac, DibChlNumber, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_event_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiGetPortsEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned short *			pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_get_ports_enable(pMac, DibChlNumber, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_get_ports_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetPortsEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned short				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_ports_enable(pMac, DibChlNumber, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_ports_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetCalibration(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned short				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_calibration_value(pMac, DibChlNumber, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_calibration_value fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetPortAiMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_port_ai_mode(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_port_ai_mode fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetPortTriggerMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_port_trigger_mode(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_port_trigger_mode fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetPortUpperTriggerValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	double		 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_port_upper_trigger_value(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_port_upper_trigger_value fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetPortLowerTriggerValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	double		 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_port_lower_trigger_value(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_port_lower_trigger_value fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiGetPortLoggingMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char * 			pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_get_logging_mode(pMac, DibChlNumber, PortChl, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_get_logging_mode fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetPortLoggingMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_logging_mode(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_logging_mode fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType0InputType(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type0_input_type(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type0_input_type fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType0InputSelect(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type0_input_select(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type0_input_select fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType0PullupResistor(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type0_pullup_resistor(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type0_pullup_resistor fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType0Gain(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type0_gain(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type0_gain fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType0Filter(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned short 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type0_filter(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type0_filter fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType1InputType(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type1_input_type(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type1_input_type fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType1InputSelect(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type1_input_select(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type1_input_select fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiGetType1PgaEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char *				pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_get_type1_pga_enable(pMac, DibChlNumber, PortChl, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_get_type1_pga_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType1PgaEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type1_pga_enable(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type1_pga_enable fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiGetType1Gain(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char *				pValue
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_get_type1_gain(pMac, DibChlNumber, PortChl, pValue);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_get_type1_gain fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetType1Gain(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = mai_set_type1_gain(pMac, DibChlNumber, PortChl, Value);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_type1_gain fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	)
{
	int							nStatus = MNG_STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		if (pMac == NULL)
		{
			break;
		}

		mai_event_register_function(IntMAiEventCallback);

		nStatus = mai_set_event_callback(pMac, DibChlNumber, IntMAiEventCallback);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_event_callback fail, code:x%02x\n",  pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}
		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibMAiSetDataCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	)
{
	int							nStatus = MNG_STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		if (pMac == NULL)
		{
			break;
		}

		mai_data_register_function(IntMAiDataCallback);

		nStatus = mai_set_data_callback(pMac, DibChlNumber, IntMAiDataCallback);
		if (nStatus != MNG_STATUS_SUCCESS)
		{
			//printf("LIB MAI (:%.2x:%.2x:%.2x), mai_set_data_callback fail, code:x%02x\n",  pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}
		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


