/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerOpen(
	unsigned char *				pMac,
	int							DibChlNumber,
	PSER_STATE_INFO				pState
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_open(pMac, DibChlNumber, pState);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_open fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerClose(
	unsigned char *				pMac,
	int							DibChlNumber
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_close(pMac, DibChlNumber);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_close fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetFifoCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				FifoCtrl
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_fifo_ctrl(pMac, DibChlNumber, FifoCtrl);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_fifo_ctrl fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetMcr(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Mcr
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_mcr(pMac, DibChlNumber, Mcr);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_mcr fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetEventCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				EventCtrl
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_event_ctrl(pMac, DibChlNumber, EventCtrl);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_event_ctrl fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetPowerIO(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Mode
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_power_io(pMac, DibChlNumber, Mode);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_power_io fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetModeCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Mode
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_mode_ctrl(pMac, DibChlNumber, Mode);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_mode_ctrl fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerWrite(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pData,
	unsigned int				DataLength
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_write(pMac, DibChlNumber, pData, DataLength);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_write fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetting(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Baudrate,
	unsigned char				Databit,
	unsigned char				Parity,
	unsigned char				Stopbit,
	unsigned char				Flowctrl
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_setting(pMac, DibChlNumber, Baudrate, Databit, Parity, Stopbit, Flowctrl);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_setting fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetBreak(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				State
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_break(pMac, DibChlNumber, State);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_break fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerGetOnChipHwFlowCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pHwFlowctrl
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_get_on_chip_hw_flow_ctrl(pMac, DibChlNumber, pHwFlowctrl);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_get_on_chip_hw_flow_ctrl fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetOnChipHwFlowCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char 				HwFlowctrl
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_on_chip_hw_flow_ctrl(pMac, DibChlNumber, HwFlowctrl);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_on_chip_hw_flow_ctrl fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerGetTxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pTriggerLevel
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_get_tx_trigger_level(pMac, DibChlNumber, pTriggerLevel);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_get_tx_trigger_level fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetTxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char 				TriggerLevel
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_tx_trigger_level(pMac, DibChlNumber, TriggerLevel);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_tx_trigger_level fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerGetRxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pTriggerLevel
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_get_rx_trigger_level(pMac, DibChlNumber, pTriggerLevel);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_get_rx_trigger_level fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetRxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char 				TriggerLevel
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = ser_set_rx_trigger_level(pMac, DibChlNumber, TriggerLevel);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_rx_trigger_level fail, Dib:%d, code:x%02x\n", pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetMsrEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		if (pMac == NULL)
		{
			break;
		}

		ser_msr_event_register_function(IntSerMsrEventCallback);

		nStatus = ser_set_msr_event_callback(pMac, DibChlNumber, IntSerMsrEventCallback);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_msr_event_callback fail, Dib:%d, code:x%02x\n",  pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}
		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetLsrEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		if (pMac == NULL)
		{
			break;
		}

		ser_lsr_event_register_function(IntSerLsrEventCallback);

		nStatus = ser_set_lsr_event_callback(pMac, DibChlNumber, IntSerLsrEventCallback);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_lsr_event_callback fail, Dib:%d, code:x%02x\n",  pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}
		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSerSetDataEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		if (pMac == NULL)
		{
			break;
		}

		ser_data_event_register_function(IntSerDataEventCallback);

		nStatus = ser_set_data_event_callback(pMac, DibChlNumber, IntSerDataEventCallback);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SER (:%.2x:%.2x:%.2x), ser_set_data_event_callback fail, Dib:%d, code:x%02x\n",  pMac[3], pMac[4], pMac[5], DibChlNumber, nStatus);
			break;
		}
		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


