/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSioConnect(
	unsigned char *				pMac,
	int							SioTcpPort
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = sio_init(pMac, SioTcpPort);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SIO (:%.2x:%.2x:%.2x), sio_init fail, code:x%02x, SioTcpPort:%d\n", pMac[3], pMac[4], pMac[5], nStatus, SioTcpPort);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSioDisconnect(
	unsigned char *				pMac
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = sio_free(pMac);
		if (nStatus != STATUS_SUCCESS)
		{
			//printf("LIB SIO (:%.2x:%.2x:%.2x), sio_free fail, code:x%02x\n", pMac[3], pMac[4], pMac[5], nStatus);
			break;
		}

		bSuccess = true; 

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LibSioGetConnection(
	unsigned char *				pMac
	)
{
	int							nStatus = STATUS_SUCCESS;
	bool						bSuccess = false;


	do
	{
		nStatus = sio_get_connection_status(pMac);
		if (nStatus == 0x01)
		{
			bSuccess = true;
		}

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


