/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioCreateCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjRoot
	)
{
	char						StringId[256] = {0};
	char						Data[256] = {0};
	int							i = 0;
	unsigned char				NumberOfBanks = pDib->Info.DioInfo.NumberOfBanks;
	unsigned char				ShareDirectionControl = pDib->Info.DioInfo.ShareDirectionControl;
	UA_NodeId					uaIdObjCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdBankCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdBankXRoot = UA_NODEID_NULL;
	UA_ObjectAttributes			uaAttrObj;
	UA_VariableAttributes		uaAttrVariable;
	UA_Int32					uaInt32;
	UA_Boolean					uaBoolean;


	// Object capabiliey object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Dio_capa");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dio_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		*pUaIdObjRoot,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Dio_capa"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdObjCapa);


	// Io_bank_amount variable node
	uaInt32 = pDib->Info.DioInfo.NumberOfBanks;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Io_bank_amount");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Io_bank_amount", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Io_bank_amount"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Io_bank_share_port_direction_enable variable node
	if (ShareDirectionControl == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Io_bank_share_port_direction_enable");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Io_bank_share_port_direction_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Io_bank_share_port_direction_enable"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	if (NumberOfBanks <= 0)
	{
		return;
	}


	// Io_bank_capa object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Io_bank_capa");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Io_bank_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Io_bank_capa"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdBankCapa);


	for (i = 0; i < NumberOfBanks; i++)
	{
		uaIdBankXRoot = UA_NODEID_NULL;


		// Io_bankX object node
		memset(Data, 0, sizeof(Data));
		sprintf(Data, "Io_bank%d", pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);
		uaAttrObj = UA_ObjectAttributes_default;
		uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", Data);
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Io_bank", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankCapa,
			UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
			UA_QUALIFIEDNAME(1, Data),
			UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdBankXRoot);


		// Bank_num variable node
		uaInt32 = pDib->Info.DioInfo.BankInfo[i].BankIndex + 1;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Bank_num");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_num", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Bank_num"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Bank_width variable node
		uaInt32 = pDib->Info.DioInfo.BankInfo[i].IoNumber;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Bank_width");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_width", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Bank_width"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Setting_flash_capa variable node
		if (pDib->Info.DioInfo.BankInfo[i].WritingSettingsCapability == 0x01)
		{
			uaBoolean = true;
		}
		else
		{
			uaBoolean = false;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Setting_flash_capa");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Setting_flash_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Setting_flash_capa"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Bank_support_inputs variable node
		if (pDib->Info.DioInfo.BankInfo[i].DirectionCapability & 0x01)
		{
			uaBoolean = true;
		}
		else
		{
			uaBoolean = false;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Bank_support_inputs");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_support_inputs", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Bank_support_inputs"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Bank_support_outputs variable node
		if (pDib->Info.DioInfo.BankInfo[i].DirectionCapability & 0x02)
		{
			uaBoolean = true;
		}
		else
		{
			uaBoolean = false;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Bank_support_outputs");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_support_outputs", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Bank_support_outputs"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Rising_trigger_capa variable node
		if (pDib->Info.DioInfo.BankInfo[i].EdgeTriggerCapability & 0x01)
		{
			uaBoolean = true;
		}
		else
		{
			uaBoolean = false;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Rising_trigger_capa");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Rising_trigger_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Rising_trigger_capa"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Falling_trigger_capa variable node
		if (pDib->Info.DioInfo.BankInfo[i].EdgeTriggerCapability & 0x02)
		{
			uaBoolean = true;
		}
		else
		{
			uaBoolean = false;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Falling_trigger_capa");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Falling_trigger_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Falling_trigger_capa"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioDeleteCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	)
{
	char						StringId[256] = {0};
	int							i = 0;

	UA_NodeId					uaIdObjCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdBankCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdBankXRoot = UA_NODEID_NULL;


	for (i = 0; i < pDib->Info.DioInfo.NumberOfBanks; i++)
	{
		// Io_bankX object node
		uaIdBankXRoot = UA_NODEID_NULL;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Io_bank", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);
		uaIdBankXRoot = UA_NODEID_STRING(1, StringId);
		UA_Server_deleteNode(pService->uaServerPtr, uaIdBankXRoot, true);
	}


	// Io_bank_capa object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Io_bank_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdBankCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdBankCapa, true);


	// Object capabiliey object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dio_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdObjCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdObjCapa, true);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioCreateInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjObj
	)
{
	char						StringId[256] = {0};
	char						Data[256] = {0};
	int							i = 0;
	int							j = 0;
	bool						bReturn = false;
	bool						bGetDioInfoSuccess = true;
	int							IoPortAmount = 0;
	unsigned char				NumberOfBanks = pDib->Info.DioInfo.NumberOfBanks;
	unsigned char				ShareDirectionControl = pDib->Info.DioInfo.ShareDirectionControl;

	UA_NodeId					uaIdObjInfo = UA_NODEID_NULL;
	UA_NodeId					uaIdBankXRoot = UA_NODEID_NULL;
	UA_NodeId					uaIdPortYRoot = UA_NODEID_NULL;
	UA_ObjectAttributes			uaAttrObj;
	UA_MethodAttributes			uaAttrMethod;
	UA_VariableAttributes		uaAttrVariable;
	UA_Argument					uaArgumentInput[2];
	UA_Argument					uaArgumentOutput;
	UA_Int32					uaInt32;
	UA_Boolean					uaBoolean;
	UA_Double					uaDouble;


	do
	{
		bReturn = LibDioGetOutputSafeValueTimer(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, &pDib->DioSaveTimerEnable, &pDib->DioSaveTimerTime);
		if (bReturn != true)
		{
			bGetDioInfoSuccess = false;
			break;
		}

		for (i = 0; i < NumberOfBanks; i++)
		{
			pDib->DioBank[i].BankIndex = pDib->Info.DioInfo.BankInfo[i].BankIndex;
			pDib->DioBank[i].SDpPtr = pSDp;
			pDib->DioBank[i].DibPtr = pDib;
			pDib->DioBank[i].BankInfoPtr = &pDib->Info.DioInfo.BankInfo[i];
			pDib->DioBank[i].IoMask = 0;

			for (j = 0; j < pDib->Info.DioInfo.BankInfo[i].IoNumber; j++)
			{
				pDib->DioBank[i].IoMask |= 0x00000001;
				if (j < (pDib->Info.DioInfo.BankInfo[i].IoNumber - 1))
				{
					pDib->DioBank[i].IoMask = pDib->DioBank[i].IoMask << 1;
				}
			}


			bReturn = LibDioGetBankDirection(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].Direction);
			if (bReturn != true)
			{
				bGetDioInfoSuccess = false;
				break;
			}

			bReturn = LibDioGetBankState(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].State);
			if (bReturn != true)
			{
				bGetDioInfoSuccess = false;
				break;
			}

			bReturn = LibDioGetBankInputEventMode(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].InputEventMode);
			if (bReturn != true)
			{
				//bGetDioInfoSuccess = false;
				//break;
			}

			bReturn = LibDioGetBankOutputPinConfig(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].OutputPinMode);
			if (bReturn != true)
			{
				//bGetDioInfoSuccess = false;
				//break;
			}


			if (pDib->DioBank[i].Direction & pDib->DioBank[i].IoMask)
			{
				bReturn = LibDioGetBankOutputInitialValue(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].OutputInitValue);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}

				bReturn = LibDioGetBankOutputSafeValue(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].OutputSafeValue);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}
			}
			else
			{
				bReturn = LibDioGetBankInputInvert(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].InputInvert);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}

				bReturn = LibDioGetBankInputLatchRisingEdge(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].InputLatchRisingEdge);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}

				bReturn = LibDioGetBankInputLatchFallingEdge(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].InputLatchFallingEdge);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}

				bReturn = LibDioGetBankInputCounterIncrementRisingEdge(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].InputCounterIncrementRisingEdge);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}

				bReturn = LibDioGetBankInputCounterIncrementFallingEdge(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, &pDib->DioBank[i].InputCounterIncrementFallingEdge);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}

				bReturn = LibDioSetBankInputEventCallback(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex);
				if (bReturn != true)
				{
					//bGetDioInfoSuccess = false;
					//break;
				}
			}


			for (j = 0; j < pDib->Info.DioInfo.BankInfo[i].IoNumber; j++)
			{
				pDib->DioBank[i].Port[j].PortIndex = j;
				pDib->DioBank[i].Port[j].SDpPtr = pSDp;
				pDib->DioBank[i].Port[j].BankPtr = &pDib->DioBank[i];


				if (!((pDib->DioBank[i].Direction >> j) & (pDib->DioBank[i].IoMask >> j)))
				{
					bReturn = LibDioGetBankIoInputCounterCounterValue(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->Info.DioInfo.BankInfo[i].BankIndex, pDib->DioBank[i].Port[j].PortIndex, &pDib->DioBank[i].Port[j].InputCounterValue);
					if (bReturn != true)
					{
						//bGetDioInfoSuccess = false;
						//break;
					}
				}
			}

			IoPortAmount += pDib->Info.DioInfo.BankInfo[i].IoNumber;
		}

	} while (false);

	// debug
	/*
	printf("***************************************\n");
	printf(" DIB number               : %d\n", pDib->Info.ChlNumber);
	printf(" DioSaveTimerEnable       : x%02x\n", pDib->DioSaveTimerEnable);
	printf(" DioSaveTimerTime         : x%02x\n", pDib->DioSaveTimerTime);
	for (i = 0; i < NumberOfBanks; i++)
	{
		printf("=======================================\n");
		printf(" BankIndex                : %d, %p\n", pDib->DioBank[i].BankIndex, &pDib->DioBank[i]);
		printf(" SDpPtr                   : %p\n", pDib->DioBank[i].SDpPtr);
		printf(" DibPtr                   : %p\n", pDib->DioBank[i].DibPtr);
		printf(" BankInfoPtr              : %p\n", pDib->DioBank[i].BankInfoPtr);
		printf(" IoMask                   : x%08x\n", pDib->DioBank[i].IoMask);
		for (j = 0; j < pDib->DioBank[i].BankInfoPtr->IoNumber; j++)
		{
			printf("---------------------------------------\n");
			printf(" PortIndex                : %d\n", pDib->DioBank[i].Port[j].PortIndex);
			printf(" SDpPtr                   : %p\n", pDib->DioBank[i].Port[j].SDpPtr);
			printf(" BankPtr                  : %p\n", pDib->DioBank[i].Port[j].BankPtr);
			printf("---------------------------------------\n");
		}
		printf("=======================================\n");
	}
	printf("***************************************\n");
	*/
	if (bGetDioInfoSuccess == false)
	{
		//printf("OPC DIO (:%.2x:%.2x:%.2x), get DIO info fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5]);
		return;
	}




	// Object info object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Dio_info");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dio_info", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		*pUaIdObjObj,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Dio_info"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdObjInfo);


	// Dio_bank_amount variable node
	uaInt32 = NumberOfBanks;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Dio_bank_amount");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dio_bank_amount", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Dio_bank_amount"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Dio_port_amount variable node
	uaInt32 = IoPortAmount;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Dio_port_amount");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dio_port_amount", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Dio_port_amount"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Output_save_timer_enable variable node
	uaBoolean = (pDib->DioSaveTimerEnable == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Output_save_timer_enable");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Output_save_timer_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Output_save_timer_enable"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Output_save_timer_time variable node
	uaDouble = (double)(((double)pDib->DioSaveTimerTime * 100) / 1000);
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Output_save_timer_time");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Output_save_timer_time", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Output_save_timer_time"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Set_output_save_timer_enable method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Output save timer enable");
	uaArgumentInput[0].name = UA_STRING("Output save timer enable");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_output_save_timer_enable");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_output_save_timer_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_output_save_timer_enable"),
		uaAttrMethod, &OpcDioCallbackSetOutputSaveTimerEnable,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// Set_output_save_timer_time method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Output save timer time");
	uaArgumentInput[0].name = UA_STRING("Output save timer time");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_DOUBLE].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_output_save_timer_time");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_output_save_timer_time", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_output_save_timer_time"),
		uaAttrMethod, &OpcDioCallbackSetOutputSaveTimerTime,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// bankX
	for (i = 0; i < NumberOfBanks; i++)
	{
		uaIdBankXRoot = UA_NODEID_NULL;


		// bankX object node
		memset(Data, 0, sizeof(Data));
		sprintf(Data, "bank%d", pDib->DioBank[i].BankIndex + 1);
		uaAttrObj = UA_ObjectAttributes_default;
		uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", Data);
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdObjInfo,
			UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
			UA_QUALIFIEDNAME(1, Data),
			UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdBankXRoot);


		// Bank_num variable node
		uaInt32 = pDib->DioBank[i].BankIndex + 1;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Bank_num");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_num", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Bank_num"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Bank_port_direction_value variable node
		if (!((pDib->DioBank[i].BankInfoPtr->DirectionCapability == 0x03) && (ShareDirectionControl == 0x00)))
		{
			if (pDib->DioBank[i].Direction & pDib->DioBank[i].IoMask)
			{
				uaInt32 = 1;
			}
			else
			{
				uaInt32 = 0;
			}
			uaAttrVariable = UA_VariableAttributes_default;
			UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
			uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Bank_port_direction_value");
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_port_direction_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

			UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				uaIdBankXRoot,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
				UA_QUALIFIEDNAME(1, "Bank_port_direction_value"),
				UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
		}


		// Input_event_trigger_mode variable node
		uaInt32 = pDib->DioBank[i].InputEventMode;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_event_trigger_mode");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Input_event_trigger_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Input_event_trigger_mode"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Set_bank_port_direction method node
		if (!((pDib->DioBank[i].BankInfoPtr->DirectionCapability == 0x03) && (ShareDirectionControl == 0x00)))
		{
			UA_Argument_init(&uaArgumentInput[0]);
			uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Bank direction");
			uaArgumentInput[0].name = UA_STRING("Bank direction");
			uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
			uaArgumentInput[0].valueRank = -1;

			uaAttrMethod = UA_MethodAttributes_default;
			uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_bank_port_direction");
			uaAttrMethod.executable = true;
			uaAttrMethod.userExecutable = true;

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Set_bank_port_direction", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

			UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				uaIdBankXRoot,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
				UA_QUALIFIEDNAME(1, "Set_bank_port_direction"),
				uaAttrMethod, &OpcDioCallbackSetBankDirection,
				1, uaArgumentInput, 0, NULL, (void *)&pDib->DioBank[pDib->Info.DioInfo.BankInfo[i].BankIndex], NULL);
		}


		// Set_event_trigger_mode method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Bank event trigger mode");
		uaArgumentInput[0].name = UA_STRING("Bank event trigger mode");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_event_trigger_mode");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Set_event_trigger_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->Info.DioInfo.BankInfo[i].BankIndex + 1);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdBankXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_event_trigger_mode"),
			uaAttrMethod, &OpcDioCallbackSetBankInputEventTriggerMode,
			1, uaArgumentInput, 0, NULL, (void *)&pDib->DioBank[pDib->Info.DioInfo.BankInfo[i].BankIndex], NULL);


		// portY
		for (j = 0; j < pDib->DioBank[i].BankInfoPtr->IoNumber; j++)
		{
			uaIdPortYRoot = UA_NODEID_NULL;


			// portY object node
			memset(Data, 0, sizeof(Data));
			sprintf(Data, "port%d", pDib->DioBank[i].Port[j].PortIndex + 1);
			uaAttrObj = UA_ObjectAttributes_default;
			uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", Data);
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Port", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

			UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				uaIdBankXRoot,
				UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
				UA_QUALIFIEDNAME(1, Data),
				UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdPortYRoot);


			// Port_num variable node
			uaInt32 = pDib->DioBank[i].Port[j].PortIndex + 1;
			uaAttrVariable = UA_VariableAttributes_default;
			UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
			uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Port_num");
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Port_num", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

			UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				uaIdPortYRoot,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
				UA_QUALIFIEDNAME(1, "Port_num"),
				UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


			// Direction variable node
			uaInt32 = (pDib->DioBank[i].Direction >> j) & 0x00000001;
			uaAttrVariable = UA_VariableAttributes_default;
			UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
			uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Direction");
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Direction", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

			UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				uaIdPortYRoot,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
				UA_QUALIFIEDNAME(1, "Direction"),
				UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


			if (((pDib->DioBank[i].Direction >> j) & 0x00000001) == 0x00000001)
			{
				// DO

				// Do_current_data variable node
				uaBoolean = ((pDib->DioBank[i].State >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Do_current_data");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Do_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Do_current_data"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Output_init_value variable node
				uaBoolean = ((pDib->DioBank[i].OutputInitValue >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Output_init_value");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Output_init_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Output_init_value"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Output_save_value variable node
				uaBoolean = ((pDib->DioBank[i].OutputSafeValue >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Output_save_value");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Output_save_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Output_save_value"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Write_DO_data method node
				UA_Argument_init(&uaArgumentInput[0]);
				uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "DO data");
				uaArgumentInput[0].name = UA_STRING("DO data");
				uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentInput[0].valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Write_DO_data");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Write_DO_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Write_DO_data"),
					uaAttrMethod, &OpcDioCallbackSetPortState,
					1, uaArgumentInput, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Set_output_init_value method node
				UA_Argument_init(&uaArgumentInput[0]);
				uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Output init value");
				uaArgumentInput[0].name = UA_STRING("Output init value");
				uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentInput[0].valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_output_init_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Set_output_init_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Set_output_init_value"),
					uaAttrMethod, &OpcDioCallbackSetPortOutputInitValue,
					1, uaArgumentInput, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Set_output_save_value method node
				UA_Argument_init(&uaArgumentInput[0]);
				uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Output save value");
				uaArgumentInput[0].name = UA_STRING("Output save value");
				uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentInput[0].valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_output_save_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Set_output_save_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Set_output_save_value"),
					uaAttrMethod, &OpcDioCallbackSetPortOutputSaveValue,
					1, uaArgumentInput, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);
			}
			else
			{
				// DI


				// Di_current_data variable node
				uaBoolean = ((pDib->DioBank[i].State >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Di_current_data");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Di_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Di_current_data"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Input_counter_increment_ctrl_reg_positive_enable variable node
				uaBoolean = ((pDib->DioBank[i].InputCounterIncrementRisingEdge >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_counter_increment_ctrl_reg_positive_enable");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_increment_ctrl_reg_positive_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Input_counter_increment_ctrl_reg_positive_enable"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Input_counter_increment_ctrl_reg_negative_enable variable node
				uaBoolean = ((pDib->DioBank[i].InputCounterIncrementFallingEdge >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_counter_increment_ctrl_reg_negative_enable");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_increment_ctrl_reg_negative_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Input_counter_increment_ctrl_reg_negative_enable"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Input_counter_reg_value variable node
				uaInt32 = pDib->DioBank[i].Port[j].InputCounterValue;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_counter_reg_value");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_reg_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Input_counter_reg_value"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Input_invert_enable variable node
				uaBoolean = ((pDib->DioBank[i].InputInvert >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_invert_enable");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_invert_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Input_invert_enable"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Input_latch_reg_positive_value variable node
				uaBoolean = ((pDib->DioBank[i].InputLatchRisingEdge >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_latch_reg_positive_value");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_latch_reg_positive_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Input_latch_reg_positive_value"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Input_latch_reg_negative_value variable node
				uaBoolean = ((pDib->DioBank[i].InputLatchFallingEdge >> j) & 0x00000001)?true:false;
				uaAttrVariable = UA_VariableAttributes_default;
				UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_latch_reg_negative_value");
				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_latch_reg_negative_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
					UA_QUALIFIEDNAME(1, "Input_latch_reg_negative_value"),
					UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


				// Read_DI_data method node
				UA_Argument_init(&uaArgumentOutput);
				uaArgumentOutput.description = UA_LOCALIZEDTEXT("en-US", "DI port data");
				uaArgumentOutput.name = UA_STRING("DI port data");
				uaArgumentOutput.dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentOutput.valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Read_DI_data");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Read_DI_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Read_DI_data"),
					uaAttrMethod, &OpcDioCallbackGetPortState,
					0, NULL, 1, &uaArgumentOutput, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Read_input_counter_reg_value method node
				UA_Argument_init(&uaArgumentOutput);
				uaArgumentOutput.description = UA_LOCALIZEDTEXT("en-US", "Input counter value");
				uaArgumentOutput.name = UA_STRING("Input counter value");
				uaArgumentOutput.dataType = UA_TYPES[UA_TYPES_INT32].typeId;
				uaArgumentOutput.valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Read_input_counter_reg_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Read_input_counter_reg_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Read_input_counter_reg_value"),
					uaAttrMethod, &OpcDioCallbackGetPortInputCounter,
					0, NULL, 1, &uaArgumentOutput, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Read_input_latch_positive_value method node
				UA_Argument_init(&uaArgumentOutput);
				uaArgumentOutput.description = UA_LOCALIZEDTEXT("en-US", "Input positive latch value");
				uaArgumentOutput.name = UA_STRING("Input positive latch value");
				uaArgumentOutput.dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentOutput.valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Read_input_latch_positive_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Read_input_latch_positive_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Read_input_latch_positive_value"),
					uaAttrMethod, &OpcDioCallbackGetPortInputLatchRisingEdge,
					0, NULL, 1, &uaArgumentOutput, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Read_input_latch_negative_value method node
				UA_Argument_init(&uaArgumentOutput);
				uaArgumentOutput.description = UA_LOCALIZEDTEXT("en-US", "Input negative latch value");
				uaArgumentOutput.name = UA_STRING("Input negative latch value");
				uaArgumentOutput.dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentOutput.valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Read_input_latch_negative_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Read_input_latch_negative_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Read_input_latch_negative_value"),
					uaAttrMethod, &OpcDioCallbackGetPortInputLatchFallingEdge,
					0, NULL, 1, &uaArgumentOutput, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Reset_input_counter_reg method node
				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Reset_input_counter_reg");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Reset_input_counter_reg", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Reset_input_counter_reg"),
					uaAttrMethod, &OpcDioCallbackResetPortInputCounter,
					0, NULL, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Reset_input_latch_positive_value method node
				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Reset_input_latch_positive_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Reset_input_latch_positive_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Reset_input_latch_positive_value"),
					uaAttrMethod, &OpcDioCallbackResetPortInputLatchRisingEdge,
					0, NULL, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Reset_input_latch_negative_value method node
				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Reset_input_latch_negative_value");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Reset_input_latch_negative_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Reset_input_latch_negative_value"),
					uaAttrMethod, &OpcDioCallbackResetPortInputLatchFallingEdge,
					0, NULL, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Set_input_counter_increment_ctrl_positive_enable method node
				UA_Argument_init(&uaArgumentInput[0]);
				uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Input counter increment positive enable");
				uaArgumentInput[0].name = UA_STRING("Input counter increment positive enable");
				uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentInput[0].valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_input_counter_increment_ctrl_positive_enable");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Set_input_counter_increment_ctrl_positive_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Set_input_counter_increment_ctrl_positive_enable"),
					uaAttrMethod, &OpcDioCallbackSetPortInputCounterIncrementRisingEdgeEnable,
					1, uaArgumentInput, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Set_input_counter_increment_ctrl_negative_enable method node
				UA_Argument_init(&uaArgumentInput[0]);
				uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Input counter increment negative enable");
				uaArgumentInput[0].name = UA_STRING("Input counter increment negative enable");
				uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentInput[0].valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_input_counter_increment_ctrl_negative_enable");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Set_input_counter_increment_ctrl_negative_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Set_input_counter_increment_ctrl_negative_enable"),
					uaAttrMethod, &OpcDioCallbackSetPortInputCounterIncrementFallingEdgeEnable,
					1, uaArgumentInput, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);


				// Set_input_invert_enable method node
				UA_Argument_init(&uaArgumentInput[0]);
				uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Input invert enable");
				uaArgumentInput[0].name = UA_STRING("Input invert enable");
				uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
				uaArgumentInput[0].valueRank = -1;

				uaAttrMethod = UA_MethodAttributes_default;
				uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_input_invert_enable");
				uaAttrMethod.executable = true;
				uaAttrMethod.userExecutable = true;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Set_input_invert_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);

				UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
					uaIdPortYRoot,
					UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
					UA_QUALIFIEDNAME(1, "Set_input_invert_enable"),
					uaAttrMethod, &OpcDioCallbackSetPortInputInvertEnable,
					1, uaArgumentInput, 0, NULL, (void *)(&pDib->DioBank[i].Port[j]), NULL);
			}
		}
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioDeleteInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	)
{
	char						StringId[256] = {0};
	int							i = 0;
	int							j = 0;
	unsigned char				NumberOfBanks = pDib->Info.DioInfo.NumberOfBanks;

	UA_NodeId					uaIdObjInfo = UA_NODEID_NULL;
	UA_NodeId					uaIdBankXRoot = UA_NODEID_NULL;
	UA_NodeId					uaIdPortYRoot = UA_NODEID_NULL;


	for (i = 0; i < NumberOfBanks; i++)
	{
		for (j = 0; j < pDib->DioBank[i].BankInfoPtr->IoNumber; j++)
		{
			// PortY object node
			uaIdPortYRoot = UA_NODEID_NULL;

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Port", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1, pDib->DioBank[i].Port[j].PortIndex + 1);
			uaIdPortYRoot = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdPortYRoot, true);
		}


		// bankX object node
		uaIdBankXRoot = UA_NODEID_NULL;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->DioBank[i].BankIndex + 1);
		uaIdBankXRoot = UA_NODEID_STRING(1, StringId);
		UA_Server_deleteNode(pService->uaServerPtr, uaIdBankXRoot, true);
	}


	// Object info object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dio_info", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdObjInfo = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdObjInfo, true);




	for (i = 0; i < 32; i++)
	{
		pDib->DioBank[i].BankIndex = 0;
		pDib->DioBank[i].SDpPtr = NULL;
		pDib->DioBank[i].DibPtr = NULL;
		pDib->DioBank[i].BankInfoPtr = NULL;

		for (j = 0; j < 32; j++)
		{
			pDib->DioBank[i].Port[j].PortIndex = 0;
			pDib->DioBank[i].Port[j].SDpPtr = NULL;
			pDib->DioBank[i].Port[j].BankPtr = NULL;
		}
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetOutputTimerEnable(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean 					uaBoolean;
	UA_Variant					uaVariant;


	if (pDib->DioSaveTimerEnable == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Output_save_timer_enable", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetOutputTimerTime(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Double 					uaDouble;
	UA_Variant					uaVariant;


	uaDouble = (double)(((double)pDib->DioSaveTimerTime * 100) / 1000);

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Output_save_timer_time", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetBankDirection(
	PSDP_DIO_BANK				pDioBank
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioBank->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32;
	UA_Variant					uaVariant;


	if (pDioBank->Direction & pDioBank->IoMask)
	{
		uaInt32 = 1;
	}
	else
	{
		uaInt32 = 0;
	}

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Bank_port_direction_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioBank->DibPtr->ObjIndex, pDioBank->BankIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetBankInputEventTriggerMode(
	PSDP_DIO_BANK				pDioBank
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioBank->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32 = pDioBank->InputEventMode;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Input_event_trigger_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioBank->DibPtr->ObjIndex, pDioBank->BankIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetBankOutputPinMode(
	PSDP_DIO_BANK				pDioBank
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioBank->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32 = pDioBank->OutputPinMode;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Outputpin_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioBank->DibPtr->ObjIndex, pDioBank->BankIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetPortOutputInitValue(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->OutputInitValue >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Output_init_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetPortOutputSaveValue(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->OutputSafeValue >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Output_save_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetPortState(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->State >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Do_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateGetPortState(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;
	int							i = 0;


	for (i = 0; i < pDioPort->BankPtr->BankInfoPtr->IoNumber; i++)
	{
		uaBoolean = ((pDioPort->BankPtr->State >> i) & 0x00000001)?true:false;


		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Di_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, i + 1);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateGetPortInputCounter(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32 = pDioPort->InputCounterValue;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_reg_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateGetPortInputLatchRisingEdge(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;
	int							i = 0;


	for (i = 0; i < pDioPort->BankPtr->BankInfoPtr->IoNumber; i++)
	{
		uaBoolean = ((pDioPort->BankPtr->InputLatchRisingEdge >> i) & 0x00000001)?true:false;


		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_latch_reg_positive_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, i + 1);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateGetPortInputLatchFallingEdge(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;
	int							i = 0;


	for (i = 0; i < pDioPort->BankPtr->BankInfoPtr->IoNumber; i++)
	{
		uaBoolean = ((pDioPort->BankPtr->InputLatchFallingEdge >> i) & 0x00000001)?true:false;


		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_latch_reg_negative_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, i + 1);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateResetPortInputCounter(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32 = pDioPort->InputCounterValue;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_reg_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateResetPortInputLatchRisingEdge(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->InputLatchRisingEdge >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_latch_reg_positive_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateResetPortInputLatchFallingEdge(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->InputLatchFallingEdge >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_latch_reg_negative_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetPortInputCounterIncrementRisingEdgeEnable(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->InputCounterIncrementRisingEdge >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_increment_ctrl_reg_positive_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetPortInputCounterIncrementFallingEdgeEnable(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->InputCounterIncrementFallingEdge >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_counter_increment_ctrl_reg_negative_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateSetPortInputInvertEnable(
	PSDP_DIO_PORT				pDioPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = ((pDioPort->BankPtr->InputInvert >> pDioPort->PortIndex) & 0x00000001)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Input_invert_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioPort->BankPtr->DibPtr->ObjIndex, pDioPort->BankPtr->BankIndex + 1, pDioPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcDioUpdateBankInputEvent(
	PSDP_DIO_BANK				pDioBank
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pDioBank->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;
	int							i = 0;


	for (i = 0; i < pDioBank->BankInfoPtr->IoNumber; i++)
	{
		if ((pDioBank->DeltaState >> i) & 0x00000001)
		{
			uaBoolean = ((pDioBank->State >> i) & 0x00000001)?true:false;


			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d-%d-%d)Di_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDioBank->DibPtr->ObjIndex, pDioBank->BankIndex + 1, i + 1);

			UA_Variant_init(&uaVariant);
			UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
			UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
		}
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetOutputSaveTimerEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcDioCallbackSetOutputSaveTimerEnable, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetOutputTimerEnable(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetOutputSaveTimerTime(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Double					uaValue1 = *(UA_Double *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcDioCallbackSetOutputSaveTimerTime, uaValue1:%f\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 25.5))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntDioSetOutputTimerTime(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetBankDirection(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_BANK				pDioBank = (PSDP_DIO_BANK)pMethodContext;
	PDP_INFO					pDpInfo = &pDioBank->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d) OpcDioCallbackSetBankDirection, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioBank->BankIndex, uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 1))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntDioSetBankDirection(pDioBank, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetBankInputEventTriggerMode(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_BANK				pDioBank = (PSDP_DIO_BANK)pMethodContext;
	PDP_INFO					pDpInfo = &pDioBank->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d) OpcDioCallbackSetBankInputEventTriggerMode, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioBank->BankIndex, uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 3))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntDioSetBankInputEventTriggerMode(pDioBank, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetBankOutputPinMode(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_BANK				pDioBank = (PSDP_DIO_BANK)pMethodContext;
	PDP_INFO					pDpInfo = &pDioBank->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d) OpcDioCallbackSetBankOutputPinMode, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioBank->BankIndex, uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 1))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntDioSetBankOutputPinMode(pDioBank, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetPortOutputInitValue(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackSetPortOutputInitValue, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetPortOutputInitValue(pDioPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetPortOutputSaveValue(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackSetPortOutputSaveValue, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetPortOutputSaveValue(pDioPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetPortState(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackSetPortState, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetPortState(pDioPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackGetPortState(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaBoolean;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackGetPortState\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioGetPortState(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

		uaBoolean = ((pDioPort->BankPtr->State >> pDioPort->PortIndex) & 0x00000001)?true:false;
		UA_Variant_setScalarCopy(pOutput, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackGetPortInputCounter(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Int32					uaInt32 = 0;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackGetPortInputCounter\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioGetPortInputCounter(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

		uaInt32 = pDioPort->InputCounterValue;
		UA_Variant_setScalarCopy(pOutput, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackGetPortInputLatchRisingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaBoolean;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackGetPortInputLatchRisingEdge\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioGetPortInputLatchRisingEdge(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

		uaBoolean = ((pDioPort->BankPtr->InputLatchRisingEdge >> pDioPort->PortIndex) & 0x00000001)?true:false;
		UA_Variant_setScalarCopy(pOutput, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackGetPortInputLatchFallingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaBoolean;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackGetPortInputLatchFallingEdge\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioGetPortInputLatchFallingEdge(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

		uaBoolean = ((pDioPort->BankPtr->InputLatchFallingEdge >> pDioPort->PortIndex) & 0x00000001)?true:false;
		UA_Variant_setScalarCopy(pOutput, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackResetPortInputCounter(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackResetPortInputCounter\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioResetPortInputCounter(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackResetPortInputLatchRisingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackResetPortInputLatchRisingEdge\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioResetPortInputLatchRisingEdge(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackResetPortInputLatchFallingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackResetPortInputLatchFallingEdge\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex);

	do
	{
		bReturn = IntDioResetPortInputLatchFallingEdge(pDioPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetPortInputCounterIncrementRisingEdgeEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackSetPortInputCounterIncrementRisingEdgeEnable, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetPortInputCounterIncrementRisingEdgeEnable(pDioPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetPortInputCounterIncrementFallingEdgeEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackSetPortInputCounterIncrementFallingEdgeEnable, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetPortInputCounterIncrementFallingEdgeEnable(pDioPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcDioCallbackSetPortInputInvertEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIO_PORT				pDioPort = (PSDP_DIO_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pDioPort->BankPtr->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (B:%d,P:%d) OpcDioCallbackSetPortInputInvertEnable, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pDioPort->BankPtr->BankIndex, pDioPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntDioSetPortInputInvertEnable(pDioPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


