/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiCreateCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjRoot
	)
{
	char						StringId[256] = {0};
	UA_NodeId					uaIdObjCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdSupportedInputSource = UA_NODEID_NULL;
	UA_ObjectAttributes			uaAttrObj;
	UA_VariableAttributes		uaAttrVariable;
	UA_Int32					uaInt32;
	UA_Boolean					uaBoolean;
	UA_Double					uaDouble;


	// Object capabiliey object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Mfai_capa");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Mfai_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		*pUaIdObjRoot,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Mfai_capa"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdObjCapa);


	// Fifo_depth variable node
	uaInt32 = pDib->Info.MaiInfo.FifoSize;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Fifo_depth");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Fifo_depth", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Fifo_depth"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Ai_port_amount variable node
	uaInt32 = pDib->Info.MaiInfo.NumInputPort;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Ai_port_amount");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ai_port_amount", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Ai_port_amount"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Resolution variable node
	uaInt32 = pDib->Info.MaiInfo.Resolution;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Resolution");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Resolution", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Resolution"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Supported_input_source object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Supported_input_source");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Supported_input_source", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Supported_input_source"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdSupportedInputSource);


	// Voltage variable node
	uaBoolean = true;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Voltage");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Voltage", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSupportedInputSource,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Voltage"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Current variable node
	uaBoolean = ((pDib->Info.MaiInfo.SupportInputSource & 0x01) == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Current");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Current", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSupportedInputSource,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Current"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Resistor variable node
	uaBoolean = ((pDib->Info.MaiInfo.SupportInputSource & 0x02) == 0x02)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Resistor");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Resistor", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSupportedInputSource,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Resistor"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Rtd variable node
	uaBoolean = ((pDib->Info.MaiInfo.SupportInputSource & 0x04) == 0x04)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Rtd");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Rtd", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSupportedInputSource,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Rtd"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Thermocouple variable node
	uaBoolean = ((pDib->Info.MaiInfo.SupportInputSource & 0x08) == 0x08)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Thermocouple");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Thermocouple", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSupportedInputSource,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Thermocouple"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Thermistor variable node
	uaBoolean = ((pDib->Info.MaiInfo.SupportInputSource & 0x10) == 0x10)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Thermistor");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Thermistor", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSupportedInputSource,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Thermistor"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Vref variable node
	uaDouble = pDib->Info.MaiInfo.Verf;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Vref");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Vref", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Vref"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiDeleteCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	)
{
	char						StringId[256] = {0};
	UA_NodeId					uaIdObjCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdSupportedInputSource = UA_NODEID_NULL;


	// Supported_input_source object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Supported_input_source", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdSupportedInputSource = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdSupportedInputSource, true);


	// Object capabiliey object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Mfai_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdObjCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdObjCapa, true);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiCreateInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjObj
	)
{
	char						StringId[256] = {0};
	char						Data[256] = {0};
	int							i = 0;
	bool						bReturn = false;
	bool						bGetMAiInfoSuccess = true;
	unsigned char				NumberOfPort = pDib->Info.MaiInfo.NumInputPort;
	UA_NodeId					uaIdObjInfo = UA_NODEID_NULL;
	UA_NodeId					uaIdPortXRoot = UA_NODEID_NULL;
	UA_ObjectAttributes			uaAttrObj;
	UA_MethodAttributes			uaAttrMethod;
	UA_VariableAttributes		uaAttrVariable;
	UA_Argument					uaArgumentInput[5];
	UA_Argument					uaArgumentOutput;
	UA_Int32					uaInt32;
	UA_Boolean					uaBoolean;
	UA_Double					uaDouble;
	int							Significand = 0;
	int							Exponent = 0;
	double						DoubleValue = 0.0;


	if (pDib->Info.MaiInfo.MAI_Type != 0x01)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), MFAI type not 0x01 is x%02x (support 0x01 only) ***********************\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->Info.MaiInfo.MAI_Type);
		pDib->Info.MaiInfo.MAI_Type = 0x01;
		sleep(1);
		return;
	}


	do
	{
		bReturn = LibMAiGetPortsEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, &pDib->MAiPortsEnable);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		bReturn = OpcMAiThreadStart(pDib);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		bReturn = LibMAiSetEventCallback(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		bReturn = LibMAiSetDataCallback(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		bReturn = LibMAiSetSampleEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x01);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		bReturn = LibMAiSetDataEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x01);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		bReturn = LibMAiSetEventEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x01);
		if (bReturn != true)
		{
			bGetMAiInfoSuccess = false;
			break;
		}


		for (i = 0; i < NumberOfPort; i++)
		{
			pDib->MAiPort[i].PortIndex = pDib->Info.MaiInfo.MaiPortInfo[i].PortIndex;
			pDib->MAiPort[i].SDpPtr = pSDp;
			pDib->MAiPort[i].DibPtr = pDib;
			pDib->MAiPort[i].PortEnable = ((pDib->MAiPortsEnable & (1 << i)) >> i);
			pDib->MAiPort[i].CurrentData = 0.0;
			pDib->MAiPort[i].MeasureMode = pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].AiMode;
			if ((pDib->Info.MaiInfo.MaiPortInfo[i].TriggerMode & 0x04) == 0x04)
			{
				pDib->MAiPort[i].TriggerEnable = 0x01;
			}
			else
			{
				pDib->MAiPort[i].TriggerEnable = 0x00;
			}
			pDib->MAiPort[i].UpperTriggerValue = pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].UpperTriggerValue;
			pDib->MAiPort[i].LowerTriggerValue = pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].LowerTriggerValue;

			if (pDib->Info.MaiInfo.MAI_Type == 0x00)
			{
				//pDib->MAiPort[i].ADCCtrlReg  = (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type0InputType);
				//pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type0InputChannel << 1);
				//pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type0PullUpResistorControl << 2);
				//pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1GainControl << 8);
				//pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type0FilterControl << 16);
			}

			if (pDib->Info.MaiInfo.MAI_Type == 0x01)
			{
				pDib->MAiPort[i].ADCCtrlReg  = (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1InputType);
				pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1InputChannel << 1);
				pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1PgaEnabel << 7);
				pDib->MAiPort[i].ADCCtrlReg |= (pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1GainControl << 8);
			}

			pDib->MAiPort[i].DataReturnInterval = 1;
			pDib->MAiPort[i].DataReturnIntervalCnt = 0;
		}

	} while (false);

	// debug
	/*
	printf("***************************************\n");
	printf(" DIB number               : %d\n", pDib->Info.ChlNumber);
	printf(" MAiPortsEnable           : x%04x\n", pDib->MAiPortsEnable);
	for (i = 0; i < NumberOfPort; i++)
	{
		printf("---------------------------------------\n");
		printf(" PortIndex                : %d, %p\n", pDib->MAiPort[i].PortIndex, &pDib->MAiPort[i]);
		printf(" SDpPtr                   : %p\n", pDib->MAiPort[i].SDpPtr);
		printf(" DibPtr                   : %p\n", pDib->MAiPort[i].DibPtr);
		printf(" PortEnable               : x%02x\n", pDib->MAiPort[i].PortEnable);
		printf(" MeasureMode              : x%02x\n", pDib->MAiPort[i].MeasureMode);
		printf(" TriggerEnable            : x%02x\n", pDib->MAiPort[i].TriggerEnable);
		printf(" UpperTriggerValue        : %f\n", pDib->MAiPort[i].UpperTriggerValue);
		printf(" LowerTriggerValue        : %f\n", pDib->MAiPort[i].LowerTriggerValue);
//		printf(" Type1InputType           : x%02x\n", pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1InputType);
//		printf(" Type1InputChannel        : x%02x\n", pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1InputChannel);
//		printf(" Type1PgaEnabel           : x%02x\n", pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1PgaEnabel);
//		printf(" Type1GainControl         : x%02x\n", pDib->Info.MaiInfo.MaiPortInfo[pDib->MAiPort[i].PortIndex].Type1GainControl);

		printf(" ADCCtrlReg               : x%08x\n", pDib->MAiPort[i].ADCCtrlReg);
		printf("---------------------------------------\n");
	}
	printf("***************************************\n");
	*/
	if (bGetMAiInfoSuccess == false)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), get MAI info fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5]);
		return;
	}




	// Object info object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Mfai_info");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Mfai_info", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		*pUaIdObjObj,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Mfai_info"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdObjInfo);


	// Ai_port_amount variable node
	uaInt32 = NumberOfPort;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Ai_port_amount");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ai_port_amount", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjInfo,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Ai_port_amount"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Ai_portX
	for (i = 0; i < NumberOfPort; i++)
	{
		uaIdPortXRoot = UA_NODEID_NULL;


		// MAi_port object node
		memset(Data, 0, sizeof(Data));
		sprintf(Data, "Ai_port%d", pDib->MAiPort[i].PortIndex + 1);
		uaAttrObj = UA_ObjectAttributes_default;
		uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", Data);
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)MAi_port", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdObjInfo,
			UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
			UA_QUALIFIEDNAME(1, Data),
			UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdPortXRoot);


		// Port_number variable node
		uaInt32 = pDib->MAiPort[i].PortIndex + 1;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Port_number");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Port_number", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Port_number"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Port_enable variable node
		uaBoolean = (pDib->MAiPort[i].PortEnable == 0x01)?true:false;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Port_enable");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Port_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Port_enable"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Ai_current_data variable node
		uaDouble = pDib->MAiPort[i].CurrentData;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Ai_current_data");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Ai_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Ai_current_data"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Mesure_mode variable node
		uaInt32 = pDib->MAiPort[i].MeasureMode;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Mesure_mode");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Mesure_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Mesure_mode"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Input_range variable node
		switch (pDib->Info.MaiInfo.MAI_Type)
		{
			case 0x00 :
				{
					uaInt32 = -1; // unknow
				}
				break;

			case 0x01 :
				{
					switch (pDib->MAiPort[i].MeasureMode)
					{
						case 0 :
							{
								switch (pDib->MAiPort[i].ADCCtrlReg)
								{
									case 0x00000480 : uaInt32 = 0; break;	// +-100mV
									case 0x00000280 : uaInt32 = 1; break;	// +-500mV
									case 0x00000180 : uaInt32 = 2; break;	// +-1V
									case 0x00000102 : uaInt32 = 3; break;	// +-5V
									case 0x00000002 : uaInt32 = 4; break;	// +-10V
									case 0x00000481 : uaInt32 = 5; break;	// 0~100mV
									case 0x00000281 : uaInt32 = 6; break;	// 0~500mV
									case 0x00000181 : uaInt32 = 7; break;	// 0~1V
									case 0x00000183 : uaInt32 = 8; break;	// 0~5V
									case 0x00000003 : uaInt32 = 9; break;	// 0~10V
									default : uaInt32 = -1; break;	// unknow
								}
							}
							break;

						case 1 :
							{
								switch (pDib->MAiPort[i].ADCCtrlReg)
								{
									case 0x00000000 : uaInt32 = 0; break;	// +-20mA
									case 0x00000001 : uaInt32 = 1; break;	// 0~20mA
									default : uaInt32 = -1; break;	// unknow
								}
							}
							break;
					}
				}
				break;

			default :
				{
					uaInt32 = -1; // unknow
				}
				break;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Input_range");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Input_range", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Input_range"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Data_return_interval variable node
		uaInt32 = pDib->MAiPort[i].DataReturnInterval;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Data_return_interval");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Data_return_interval", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Data_return_interval"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Trigger_enable variable node
		uaBoolean = (pDib->MAiPort[i].TriggerEnable == 0x01)?true:false;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "TriggerEnable");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)TriggerEnable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "TriggerEnable"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Upper_trigger_value variable node
		uaDouble = pDib->MAiPort[i].UpperTriggerValue;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Upper_trigger_value");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Upper_trigger_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Upper_trigger_value"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Lower_trigger_value variable node
		uaDouble = pDib->MAiPort[i].LowerTriggerValue;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Lower_trigger_value");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Lower_trigger_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Lower_trigger_value"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


		// Read_data method node
		UA_Argument_init(&uaArgumentOutput);
		uaArgumentOutput.description = UA_LOCALIZEDTEXT("en-US", "Data");
		uaArgumentOutput.name = UA_STRING("Data");
		uaArgumentOutput.dataType = UA_TYPES[UA_TYPES_DOUBLE].typeId;
		uaArgumentOutput.valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Read_data");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Read_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Read_data"),
			uaAttrMethod, &OpcMAiCallbackReadData,
			0, NULL, 1, &uaArgumentOutput, (void *)&pDib->MAiPort[i], NULL);


		// Set_port_enable method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Port enable");
		uaArgumentInput[0].name = UA_STRING("Port enable");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_port_enable");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Set_port_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_port_enable"),
			uaAttrMethod, &OpcMAiCallbackSetPortEnable,
			1, uaArgumentInput, 0, NULL, (void *)&pDib->MAiPort[i], NULL);


		// Set_measure_mode method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Measure mode");
		uaArgumentInput[0].name = UA_STRING("Measure mode");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
		uaArgumentInput[0].valueRank = -1;

		UA_Argument_init(&uaArgumentInput[1]);
		uaArgumentInput[1].description = UA_LOCALIZEDTEXT("en-US", "Input range");
		uaArgumentInput[1].name = UA_STRING("Input range");
		uaArgumentInput[1].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
		uaArgumentInput[1].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_measure_mode");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Set_measure_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_measure_mode"),
			uaAttrMethod, &OpcMAiCallbackSetMeasureMode,
			2, uaArgumentInput, 0, NULL, (void *)&pDib->MAiPort[i], NULL);


		// Set_trigger_range method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Trigger enable");
		uaArgumentInput[0].name = UA_STRING("Trigger enable");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
		uaArgumentInput[0].valueRank = -1;

		UA_Argument_init(&uaArgumentInput[1]);
		uaArgumentInput[1].description = UA_LOCALIZEDTEXT("en-US", "Start range");
		uaArgumentInput[1].name = UA_STRING("Start range");
		uaArgumentInput[1].dataType = UA_TYPES[UA_TYPES_DOUBLE].typeId;
		uaArgumentInput[1].valueRank = -1;

		UA_Argument_init(&uaArgumentInput[2]);
		uaArgumentInput[2].description = UA_LOCALIZEDTEXT("en-US", "End range");
		uaArgumentInput[2].name = UA_STRING("End range");
		uaArgumentInput[2].dataType = UA_TYPES[UA_TYPES_DOUBLE].typeId;
		uaArgumentInput[2].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_trigger_range");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Set_trigger_range", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_trigger_range"),
			uaAttrMethod, &OpcMAiCallbackSetTriggerRange,
			3, uaArgumentInput, 0, NULL, (void *)&pDib->MAiPort[i], NULL);


		// Set_data_return_interval method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Time interval (second)");
		uaArgumentInput[0].name = UA_STRING("Time interval (second)");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_data_return_interval");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Set_data_return_interval", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			uaIdPortXRoot,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_data_return_interval"),
			uaAttrMethod, &OpcMAiCallbackSetDataReturnInterval,
			1, uaArgumentInput, 0, NULL, (void *)&pDib->MAiPort[i], NULL);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiDeleteInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	)
{
	char						StringId[256] = {0};
	int							i = 0;
	unsigned char				NumberOfPorts = pDib->Info.MaiInfo.NumInputPort;
	bool						bReturn = false;

	UA_NodeId					uaIdObjInfo = UA_NODEID_NULL;
	UA_NodeId					uaIdPortXRoot = UA_NODEID_NULL;


	if (pDib->Info.MaiInfo.MAI_Type != 0x01)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), MFAI type not 0x01 is x%02x (support 0x01 only)\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->Info.MaiInfo.MAI_Type);
		return;
	}


	bReturn = LibMAiSetPortsEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x0000);
	if (bReturn != true)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), set ports  disable fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->Info.MaiInfo.MAI_Type);
	}


	bReturn = LibMAiSetSampleEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x00);
	if (bReturn != true)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), set sample disable fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->Info.MaiInfo.MAI_Type);
	}


	bReturn = LibMAiSetDataEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x00);
	if (bReturn != true)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), set data disable fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->Info.MaiInfo.MAI_Type);
	}


	bReturn = LibMAiSetEventEnable(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, 0x00);
	if (bReturn != true)
	{
		//printf("OPC MAI (:%.2x:%.2x:%.2x), set event disable fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->Info.MaiInfo.MAI_Type);
	}


	OpcMAiThreadStop(pDib);


	for (i = 0; i < NumberOfPorts; i++)
	{
		// MAi_portX object node
		uaIdPortXRoot = UA_NODEID_NULL;

		bReturn = LibMAiSetPortLoggingMode(pSDp->DpInfo.Mac, pDib->ObjIndex, pDib->MAiPort[i].PortIndex, 0x00);
		if (bReturn != true)
		{
			//printf("OPC MAI (:%.2x:%.2x:%.2x), set port (%d) logging mode fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->MAiPort[i].PortIndex);
		}

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d-%d)MAi_port", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex, pDib->MAiPort[i].PortIndex + 1);
		uaIdPortXRoot = UA_NODEID_STRING(1, StringId);
		UA_Server_deleteNode(pService->uaServerPtr, uaIdPortXRoot, true);
	}


	// Object info object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Mfai_info", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdObjInfo = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdObjInfo, true);


	for (i = 0; i < 32; i++)
	{
		pDib->MAiPort[i].PortIndex = 0;
		pDib->DioBank[i].SDpPtr = NULL;
		pDib->DioBank[i].DibPtr = NULL;
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiUpdateReadData(
	PSDP_MAI_PORT				pMAiPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pMAiPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Double					uaDouble = pMAiPort->CurrentData;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Ai_current_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiUpdateSetPortEnable(
	PSDP_MAI_PORT				pMAiPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pMAiPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = (pMAiPort->PortEnable == 0x01)?true:false;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Port_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiUpdateSetMeasureMode(
	PSDP_MAI_PORT				pMAiPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pMAiPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32 = 0;
	UA_Variant					uaVariant;


	uaInt32 = pMAiPort->MeasureMode;
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Mesure_mode", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	switch (pMAiPort->DibPtr->Info.MaiInfo.MAI_Type)
	{
		case 0x00 :
			{
				uaInt32 = -1; // unknow
			}
			break;

		case 0x01 :
			{
				switch (pMAiPort->MeasureMode)
				{
					case 0 :
						{
							switch (pMAiPort->ADCCtrlReg)
							{
								case 0x00000480 : uaInt32 = 0; break;	// +-100mV
								case 0x00000280 : uaInt32 = 1; break;	// +-500mV
								case 0x00000180 : uaInt32 = 2; break;	// +-1V
								case 0x00000102 : uaInt32 = 3; break;	// +-5V
								case 0x00000002 : uaInt32 = 4; break;	// +-10V
								case 0x00000481 : uaInt32 = 5; break;	// 0~100mV
								case 0x00000281 : uaInt32 = 6; break;	// 0~500mV
								case 0x00000181 : uaInt32 = 7; break;	// 0~1V
								case 0x00000183 : uaInt32 = 8; break;	// 0~5V
								case 0x00000003 : uaInt32 = 9; break;	// 0~10V
								default : uaInt32 = -1; break;	// unknow
							}
						}
						break;

					case 1 :
						{
							switch (pMAiPort->ADCCtrlReg)
							{
								case 0x00000000 : uaInt32 = 0; break;	// +-20mA
								case 0x00000001 : uaInt32 = 1; break;	// 0~20mA
								default : uaInt32 = -1; break;	// unknow
							}
						}
						break;
				}
			}
			break;

		default :
			{
				uaInt32 = -1; // unknow
			}
			break;
	}
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Input_range", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiUpdateSetTriggerRange(
	PSDP_MAI_PORT				pMAiPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pMAiPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Double					uaDouble = 0.0;
	UA_Boolean					uaBoolean = false;
	UA_Variant					uaVariant;


	uaBoolean = (pMAiPort->TriggerEnable == 0x01)?true:false;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)TriggerEnable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);




	uaDouble = pMAiPort->LowerTriggerValue;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Lower_trigger_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);




	uaDouble = pMAiPort->UpperTriggerValue;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Upper_trigger_value", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcMAiUpdateSetDataReturnInterval(
	PSDP_MAI_PORT				pMAiPort
	)
{
	POPC_SERVICE				pService = &OpcService;
	PSDP_DEVICE					pSDp = pMAiPort->SDpPtr;
	char						StringId[256] = {0};
	UA_Int32					uaInt32 = pMAiPort->DataReturnInterval;
	UA_Variant					uaVariant;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d-%d)Data_return_interval", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pMAiPort->DibPtr->ObjIndex, pMAiPort->PortIndex + 1);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcMAiCallbackReadData(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_MAI_PORT				pMAiPort = (PSDP_MAI_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pMAiPort->SDpPtr->DpInfo;
	UA_Double					uaDouble = 0.0;
	

	//printf("OPC (:%.2x:%.2x:%.2x), (P:%d) OpcMAiCallbackReadData\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pMAiPort->PortIndex);

	do
	{
		bReturn = IntMAiReadData(pMAiPort);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}


		uaDouble = 0.0;
		UA_Variant_setScalarCopy(pOutput, &uaDouble, &UA_TYPES[UA_TYPES_DOUBLE]);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcMAiCallbackSetPortEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_MAI_PORT				pMAiPort = (PSDP_MAI_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pMAiPort->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (P:%d) OpcMAiCallbackSetPortEnable, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pMAiPort->PortIndex, uaValue1?"true":"false");

	do
	{
		bReturn = IntMAiSetPortEnable(pMAiPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcMAiCallbackSetMeasureMode(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_MAI_PORT				pMAiPort = (PSDP_MAI_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pMAiPort->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;
	UA_Int32					uaValue2 = *(UA_Int32 *)pInput[1].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (P:%d) OpcMAiCallbackSetMeasureMode, uaValue1:%d, uaValue2:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pMAiPort->PortIndex, uaValue1, uaValue2);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 5))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue1 == 1) && ((pMAiPort->DibPtr->Info.MaiInfo.SupportInputSource & 0x01) != 0x01))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue1 == 2) && ((pMAiPort->DibPtr->Info.MaiInfo.SupportInputSource & 0x02) != 0x02))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue1 == 3) && ((pMAiPort->DibPtr->Info.MaiInfo.SupportInputSource & 0x04) != 0x04))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue1 == 4) && ((pMAiPort->DibPtr->Info.MaiInfo.SupportInputSource & 0x08) != 0x08))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue1 == 5) && ((pMAiPort->DibPtr->Info.MaiInfo.SupportInputSource & 0x10) != 0x10))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if (uaValue1 == 0)
		{
			if ((uaValue2 < 0) || (uaValue2 > 9))
			{
				uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
				break;
			}
		}

		if (uaValue1 == 1)
		{
			if ((uaValue2 < 0) || (uaValue2 > 1))
			{
				uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
				break;
			}
		}

		bReturn = IntMAiSetMeasureMode(pMAiPort, uaValue1, uaValue2);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcMAiCallbackSetTriggerRange(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_MAI_PORT				pMAiPort = (PSDP_MAI_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pMAiPort->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;
	UA_Double					uaValue2 = *(UA_Double *)pInput[1].data;
	UA_Double					uaValue3 = *(UA_Double *)pInput[2].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (P:%d) OpcMAiCallbackSetTriggerRange, uaValue1:%s, uaValue2:%f, uaValue3:%f\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pMAiPort->PortIndex, uaValue1?"true":"false", uaValue2, uaValue3);

	do
	{
		bReturn = IntMAiSetTriggerRange(pMAiPort, uaValue1, uaValue2, uaValue3);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcMAiCallbackSetDataReturnInterval(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_MAI_PORT				pMAiPort = (PSDP_MAI_PORT)pMethodContext;
	PDP_INFO					pDpInfo = &pMAiPort->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), (P:%d) OpcMAiCallbackSetDataReturnInterval, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], pMAiPort->PortIndex, uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 600))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntMAiSetDataReturnInterval(pMAiPort, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


