/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerCreateCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjRoot
	)
{
	char						StringId[256] = {0};

	UA_NodeId					uaIdObjCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdSerTypeCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdRiPowerIoCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdDcdPowerIoCapa = UA_NODEID_NULL;

	UA_ObjectAttributes			uaAttrObj;
	UA_VariableAttributes		uaAttrVariable;
	UA_Int32					uaInt32;
	UA_Boolean					uaBoolean;


	// Object capabiliey object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Serial_capa");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		*pUaIdObjRoot,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Serial_capa"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdObjCapa);


	// Serial_type object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Serial_type");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_type", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Serial_type"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdSerTypeCapa);


	// RS232_enable variable node
	if (pDib->Info.SerInfo.RS232Capability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "RS232_enable");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)RS232_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSerTypeCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "RS232_enable"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// RS422_enable variable node
	if (pDib->Info.SerInfo.RS422Capability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "RS422_enable");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)RS422_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSerTypeCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "RS422_enable"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// RS485_enable variable node
	if (pDib->Info.SerInfo.RS485Capability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "RS485_enable");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)RS485_enable", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdSerTypeCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "RS485_enable"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Termination_422_ctrl variable node
	if (pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Termination_422_ctrl");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_422_ctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Termination_422_ctrl"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Termination_485_ctrl variable node
	if (pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Termination_485_ctrl");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_485_ctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Termination_485_ctrl"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Ri_powerio object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Ri_powerio");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ri_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Ri_powerio"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdRiPowerIoCapa);


	// Ri_power_io_5v variable node
	if (pDib->Info.SerInfo.RIPowerIOCapability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Ri_power_io_5v");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ri_power_io_5v", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdRiPowerIoCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Ri_power_io_5v"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Ri_power_io_12v variable node
	if (pDib->Info.SerInfo.RIPowerIOCapability == 0x02)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Ri_power_io_12v");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ri_power_io_12v", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdRiPowerIoCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Ri_power_io_12v"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Ri_power_io_no_distinguish variable node
	if (pDib->Info.SerInfo.RIPowerIOCapability == 0x03)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Ri_power_io_no_distinguish");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ri_power_io_no_distinguish", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdRiPowerIoCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Ri_power_io_no_distinguish"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Dcd_powerio object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Dcd_powerio");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dcd_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Dcd_powerio"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &uaIdDcdPowerIoCapa);


	// Dcd_power_io_5v variable node
	if (pDib->Info.SerInfo.DCDPowerIOCapability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Dcd_power_io_5v");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dcd_power_io_5v", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdDcdPowerIoCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Dcd_power_io_5v"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Dcd_power_io_12v variable node
	if (pDib->Info.SerInfo.DCDPowerIOCapability == 0x02)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Dcd_power_io_12v");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dcd_power_io_12v", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdDcdPowerIoCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Dcd_power_io_12v"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Dcd_power_io_no_distinguish variable node
	if (pDib->Info.SerInfo.DCDPowerIOCapability == 0x03)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Dcd_power_io_no_distinguish");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dcd_power_io_no_distinguish", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdDcdPowerIoCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Dcd_power_io_no_distinguish"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Carrier_sense variable node
	if (pDib->Info.SerInfo.CSCapability == 0x01)
	{
		uaBoolean = true;
	}
	else
	{
		uaBoolean = false;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Carrier_sense");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Carrier_sense", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		uaIdObjCapa,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Carrier_sense"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerDeleteCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	)
{
	char						StringId[256] = {0};
	int							i = 0;

	UA_NodeId					uaIdObjCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdSerTypeCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdRiPowerIoCapa = UA_NODEID_NULL;
	UA_NodeId					uaIdDcdPowerIoCapa = UA_NODEID_NULL;


	// Dcd_powerio object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dcd_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdDcdPowerIoCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdDcdPowerIoCapa, true);


	// Ri_powerio object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Ri_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdRiPowerIoCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdRiPowerIoCapa, true);


	// Serial_type object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_type", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdSerTypeCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdSerTypeCapa, true);


	// Object capabiliey object node
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_capa", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);
	uaIdObjCapa = UA_NODEID_STRING(1, StringId);
	UA_Server_deleteNode(pService->uaServerPtr, uaIdObjCapa, true);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerCreateInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjObj
	)
{
	char						StringId[256] = {0};
	char						Data[256] = {0};
	int							i = 0;
	int							j = 0;
	bool						bReturn = false;
	bool						bGetSerInfoSuccess = true;
	bool						bOpenSuccess = false;
	SER_STATE_INFO				SerState;

	UA_ObjectAttributes			uaAttrObj;
	UA_MethodAttributes			uaAttrMethod;
	UA_VariableAttributes		uaAttrVariable;
	UA_Argument					uaArgumentInput[5];
	UA_Argument					uaArgumentOutput[5];
	UA_Int32					uaInt32;
	UA_Boolean					uaBoolean;
	UA_String					uaString;


	do
	{
		bReturn = LibSerOpen(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, &SerState);
		if (bReturn != true)
		{
			bGetSerInfoSuccess = false;
			break;
		}
		bOpenSuccess = true;


		pDib->SerVersion = SerState.version;
		pDib->SerMcr = SerState.mcr;
		pDib->SerEventCtrl = SerState.event_ctrl;
		pDib->SerOnChipHwFlowCtrl = SerState.on_chip_hw_flow_ctrl;
		pDib->SerMsr = SerState.msr;
		pDib->SerTxTriggerLevel = SerState.tx_trigger_level;
		pDib->SerRxTriggerLevel = SerState.rx_trigger_level;
		pDib->SerPowerIO = SerState.power_io;
		pDib->SerModeCtrl = SerState.mode_control;

		pDib->SerEventCtrl = 0x03;

		pDib->SerBaudrate = 0x0a;
		pDib->SerDatabit = 0x03;
		pDib->SerParity = 0x00;
		pDib->SerStopbit = 0x00;
		pDib->SerFlowctrl = 0x00;
		pDib->SerBreak = 0x00;


		bReturn = LibSerSetting(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->SerBaudrate, pDib->SerDatabit, pDib->SerParity, pDib->SerStopbit, pDib->SerFlowctrl);
		if (bReturn != true)
		{
			bGetSerInfoSuccess = false;
			break;
		}

		bReturn = LibSerSetMsrEventCallback(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
		if (bReturn != true)
		{
			bGetSerInfoSuccess = false;
			break;
		}

		bReturn = LibSerSetLsrEventCallback(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
		if (bReturn != true)
		{
			bGetSerInfoSuccess = false;
			break;
		}

		bReturn = LibSerSetDataEventCallback(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
		if (bReturn != true)
		{
			bGetSerInfoSuccess = false;
			break;
		}

		bReturn = LibSerSetEventCtrl(pSDp->DpInfo.Mac, pDib->Info.ChlNumber, pDib->SerEventCtrl);
		if (bReturn != true)
		{
			bGetSerInfoSuccess = false;
			break;
		}

	} while (false);

	// debug
	/*
	printf("***************************************\n");
	printf(" DIB number               : %d\n", pDib->Info.ChlNumber);
	printf(" SerVersion               : x%02x\n", pDib->SerVersion);
	printf(" SerMcr                   : x%02x\n", pDib->SerMcr);
	printf(" SerEventCtrl             : x%02x\n", pDib->SerEventCtrl);
	printf(" SerOnChipHwFlowCtrl      : x%02x\n", pDib->SerOnChipHwFlowCtrl);
	printf(" SerTxTriggerLevel        : x%02x\n", pDib->SerTxTriggerLevel);
	printf(" SerRxTriggerLevel        : x%02x\n", pDib->SerRxTriggerLevel);
	printf(" SerPowerIO               : x%02x\n", pDib->SerPowerIO);
	printf(" SerModeCtrl              : x%02x\n", pDib->SerModeCtrl);
	printf(" SerMsr                   : x%02x\n", pDib->SerMsr);
	printf(" TransmitCapability       : x%02x\n", pDib->Info.SerInfo.TransmitCapability);
	//printf(" AHDCCapability           : x%02x\n", pDib->Info.SerInfo.AHDCCapability);
	printf(" CSCapability             : x%02x\n", pDib->Info.SerInfo.CSCapability);
	printf(" RS422TerminationCtlCapability : x%02x\n", pDib->Info.SerInfo.RS422TerminationCtlCapability);
	printf(" RS485TerminationCtlCapability : x%02x\n", pDib->Info.SerInfo.RS485TerminationCtlCapability);
	//printf(" RIPowerIOCapability      : x%02x\n", pDib->Info.SerInfo.RIPowerIOCapability);
	//printf(" DCDPowerIOCapability     : x%02x\n", pDib->Info.SerInfo.DCDPowerIOCapability);
	printf("***************************************\n");
	*/
	if (bGetSerInfoSuccess == false)
	{
		//printf("OPC SER (:%.2x:%.2x:%.2x), get SER info fail\n", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5]);
		if (bOpenSuccess == true)
		{
			bReturn = LibSerClose(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
			if (bReturn != true)
			{

			}
		}
		return;
	}




	// Object info object node
	uaAttrObj = UA_ObjectAttributes_default;
	uaAttrObj.displayName = UA_LOCALIZEDTEXT("en-US", "Serial_info");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_info", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addObjectNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		*pUaIdObjObj,
		UA_NODEID_NUMERIC(0, UA_NS0ID_ORGANIZES),
		UA_QUALIFIEDNAME(1, "Serial_info"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_FOLDERTYPE), uaAttrObj, NULL, &pDib->SerUaObjectInfoNodeId);


	// Serial_interface variable node
	if ((pDib->SerModeCtrl & 0x01) == 0x01)
	{
		uaInt32 = 1;
	}
	else if ((pDib->SerModeCtrl & 0x02) == 0x02)
	{
		uaInt32 = 2;
	}
	else if ((pDib->SerModeCtrl & 0x04) == 0x04)
	{
		uaInt32 = 3;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Serial_interface");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_interface", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Serial_interface"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Baud_rate variable node
	switch (pDib->SerBaudrate)
	{
		case 0x00 : uaInt32 = 50; break;
		case 0x01 : uaInt32 = 75; break;
		case 0x02 : uaInt32 = 110; break;
		case 0x03 : uaInt32 = 134; break;
		case 0x04 : uaInt32 = 150; break;
		case 0x05 : uaInt32 = 300; break;
		case 0x06 : uaInt32 = 600; break;
		case 0x07 : uaInt32 = 1200; break;
		case 0x08 : uaInt32 = 2400; break;
		case 0x09 : uaInt32 = 4800; break;
		case 0x0a : uaInt32 = 9600; break;
		case 0x0b : uaInt32 = 19200; break;
		case 0x0c : uaInt32 = 38400; break;
		case 0x0d : uaInt32 = 57600; break;
		case 0x0e : uaInt32 = 115200; break;
		case 0x0f : uaInt32 = 230400; break;
		case 0x10 : uaInt32 = 460800; break;
		case 0x11 : uaInt32 = 921600; break;
		default : uaInt32 = 0; break;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Baud_rate");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Baud_rate", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Baud_rate"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Databits variable node
	switch (pDib->SerDatabit)
	{
		case 0x00 : uaInt32 = 5; break;	// 5
		case 0x01 : uaInt32 = 6; break;	// 6
		case 0x02 : uaInt32 = 7; break;	// 7
		case 0x03 : uaInt32 = 8; break;	// 8
		default : uaInt32 = 0; break;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Databits");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Databits", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Databits"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Parity variable node
	switch (pDib->SerParity)
	{
		case 0x00 : uaInt32 = 0; break;	// none
		case 0x01 : uaInt32 = 1; break;	// old
		case 0x02 : uaInt32 = 2; break;	// even
		case 0x03 : uaInt32 = 3; break;	// mark
		case 0x04 : uaInt32 = 4; break;	// space
		default : uaInt32 = 0; break;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Parity");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Parity", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Parity"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Stopbits variable node
	switch (pDib->SerStopbit)
	{
		case 0x00 : uaInt32 = 1; break;	// 1
		case 0x01 : uaInt32 = 3; break;	// 1.5
		case 0x02 : uaInt32 = 2; break;	// 2
		default : uaInt32 = 0; break;
	}
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Stopbits");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Stopbits", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Stopbits"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Flowctrl variable node
	if (pDib->SerVersion <= 3)
	{
		switch (pDib->SerFlowctrl)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// RTS/CTS
			case 0x02 : uaInt32 = 2; break;	// DTR/DSR
			default : uaInt32 = 0; break;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Flowctrl");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Flowctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Flowctrl"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}
	else
	{
		switch (pDib->SerOnChipHwFlowCtrl)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// RTS/CTS
			case 0x02 : uaInt32 = 2; break;	// DTR/DSR
			case 0x03 : uaInt32 = 3; break;	// both
			default : uaInt32 = 0; break;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Flowctrl");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Flowctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Flowctrl"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}


	// Dtr variable node
	uaBoolean = ((pDib->SerMcr & 0x02) == 0x02)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Dtr");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dtr", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Dtr"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Rts variable node
	uaBoolean = ((pDib->SerMcr & 0x01) == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Rts");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Rts", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Rts"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Break variable node
	uaBoolean = ((pDib->SerBreak & 0x01) == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Break");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Break", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Break"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	if ((pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x02) == 0x02))
	{
		// Termination_422_ctrl variable node
		uaBoolean = ((pDib->SerModeCtrl & 0x20) == 0x20)?true:false;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Termination_422_ctrl");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_422_ctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Termination_422_ctrl"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}


	if ((pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
	{
		// Termination_485_ctrl variable node
		uaBoolean = ((pDib->SerModeCtrl & 0x40) == 0x40)?true:false;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Termination_485_ctrl");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_485_ctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Termination_485_ctrl"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}


	if (pDib->Info.SerInfo.RIPowerIOCapability & 0x03)
	{
		// RI_powerio variable node
		switch (pDib->SerPowerIO & 0x03)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// 5v
			case 0x02 : uaInt32 = 2; break;	// 12v
			case 0x03 : uaInt32 = 3; break;	// no distinguish
			default : uaInt32 = 0; break;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "RI_powerio");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)RI_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "RI_powerio"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}


	if (pDib->Info.SerInfo.DCDPowerIOCapability & 0x03)
	{
		// DCD_powerio variable node
		switch ((pDib->SerPowerIO & 0x0c) >> 2)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// 5v
			case 0x02 : uaInt32 = 2; break;	// 12v
			case 0x03 : uaInt32 = 3; break;	// no distinguish
			default : uaInt32 = 0; break;
		}
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "DCD_powerio");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)DCD_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "DCD_powerio"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}


	if ((pDib->Info.SerInfo.CSCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
	{
		// Carrier_sense variable node
		uaBoolean = ((pDib->SerModeCtrl & 0x10) == 0x10)?true:false;
		uaAttrVariable = UA_VariableAttributes_default;
		UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Carrier_sense");
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Carrier_sense", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
			UA_QUALIFIEDNAME(1, "Carrier_sense"),
			UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);
	}


	// Msr_cts variable node
	uaBoolean = ((pDib->SerMsr & 0x01) == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Msr_cts");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_cts", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Msr_cts"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Msr_dsr variable node
	uaBoolean = ((pDib->SerMsr & 0x02) == 0x02)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Msr_dsr");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_dsr", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Msr_dsr"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Msr_dcd variable node
	uaBoolean = ((pDib->SerMsr & 0x08) == 0x08)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Msr_dcd");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_dcd", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Msr_dcd"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Msr_ri variable node
	uaBoolean = ((pDib->SerMsr & 0x04) == 0x04)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Msr_ri");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_ri", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Msr_ri"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Lsr_frame_err variable node
	uaBoolean = (pDib->SerLsrFrameErrorState == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Lsr_frame_err");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_frame_err", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Lsr_frame_err"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Lsr_parity_err variable node
	uaBoolean = (pDib->SerLsrParityErrorState == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Lsr_parity_err");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_parity_err", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Lsr_parity_err"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Lsr_break_err variable node
	uaBoolean = (pDib->SerLsrBreakErrorState == 0x01)?true:false;
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Lsr_break_err");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_break_err", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Lsr_break_err"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Serial_read_data variable node
	uaString = UA_STRING("");
	uaAttrVariable = UA_VariableAttributes_default;
	UA_Variant_setScalar(&uaAttrVariable.value, &uaString, &UA_TYPES[UA_TYPES_STRING]);
	uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Serial_read_data");
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_read_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
		UA_QUALIFIEDNAME(1, "Serial_read_data"),
		UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);


	// Set_interface method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Interface");
	uaArgumentInput[0].name = UA_STRING("Interface");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_interface");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_interface", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_interface"),
		uaAttrMethod, &OpcSerCallbackSetInterface,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// Set_serial_parameters method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Baudrate");
	uaArgumentInput[0].name = UA_STRING("Baudrate");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
	uaArgumentInput[0].valueRank = -1;

	UA_Argument_init(&uaArgumentInput[1]);
	uaArgumentInput[1].description = UA_LOCALIZEDTEXT("en-US", "Databits");
	uaArgumentInput[1].name = UA_STRING("Databits");
	uaArgumentInput[1].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
	uaArgumentInput[1].valueRank = -1;

	UA_Argument_init(&uaArgumentInput[2]);
	uaArgumentInput[2].description = UA_LOCALIZEDTEXT("en-US", "Parity");
	uaArgumentInput[2].name = UA_STRING("Parity");
	uaArgumentInput[2].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
	uaArgumentInput[2].valueRank = -1;

	UA_Argument_init(&uaArgumentInput[3]);
	uaArgumentInput[3].description = UA_LOCALIZEDTEXT("en-US", "Stopbits");
	uaArgumentInput[3].name = UA_STRING("Stopbits");
	uaArgumentInput[3].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
	uaArgumentInput[3].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_serial_parameters");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_serial_parameters", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_serial_parameters"),
		uaAttrMethod, &OpcSerCallbackSetParameters,
		4, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// Set_flowctrl method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Flowctrl");
	uaArgumentInput[0].name = UA_STRING("Flowctrl");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_flowctrl");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_flowctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_flowctrl"),
		uaAttrMethod, &OpcSerCallbackSetFlowctrl,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// Set_dtr method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "DTR");
	uaArgumentInput[0].name = UA_STRING("DTR");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_dtr");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_dtr", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_dtr"),
		uaAttrMethod, &OpcSerCallbackSetDtr,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// Set_rts method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "RTS");
	uaArgumentInput[0].name = UA_STRING("RTS");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_rts");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_rts", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_rts"),
		uaAttrMethod, &OpcSerCallbackSetRts,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	// Set_break method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "State");
	uaArgumentInput[0].name = UA_STRING("State");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_break");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Set_break", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Set_break"),
		uaAttrMethod, &OpcSerCallbackSetBreak,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);


	if ((pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x02) == 0x02))
	{
		// Set_termination_422_ctrl method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Termination RS422 ctrl");
		uaArgumentInput[0].name = UA_STRING("Termination RS422 ctrl");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_termination_422_ctrl");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_422_ctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_termination_422_ctrl"),
			uaAttrMethod, &OpcSerCallbackSetTermination422Ctrl,
			1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
	}


	if ((pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
	{
		// Set_termination_485_ctrl method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Termination RS485 ctrl");
		uaArgumentInput[0].name = UA_STRING("Termination RS485 ctrl");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_termination_485_ctrl");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_485_ctrl", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_termination_485_ctrl"),
			uaAttrMethod, &OpcSerCallbackSetTermination485Ctrl,
			1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
	}


	if (pDib->Info.SerInfo.RIPowerIOCapability & 0x03)
	{
		// Set_Ri_powerio method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "RI power I/O");
		uaArgumentInput[0].name = UA_STRING("RI power I/O");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_Ri_powerio");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Set_Ri_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_Ri_powerio"),
			uaAttrMethod, &OpcSerCallbackSetRiPowerIO,
			1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
	}


	if (pDib->Info.SerInfo.DCDPowerIOCapability & 0x03)
	{
		// Set_Dcd_powerio method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "DCD power I/O");
		uaArgumentInput[0].name = UA_STRING("DCD power I/O");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_INT32].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_Dcd_powerio");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Set_Dcd_powerio", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_Dcd_powerio"),
			uaAttrMethod, &OpcSerCallbackSetDcdPowerIO,
			1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
	}


	if ((pDib->Info.SerInfo.CSCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
	{
		// Set_Carrier_sense method node
		UA_Argument_init(&uaArgumentInput[0]);
		uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Carrier sense");
		uaArgumentInput[0].name = UA_STRING("Carrier sense");
		uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
		uaArgumentInput[0].valueRank = -1;

		uaAttrMethod = UA_MethodAttributes_default;
		uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_Carrier_sense");
		uaAttrMethod.executable = true;
		uaAttrMethod.userExecutable = true;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Set_Carrier_sense", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
			pDib->SerUaObjectInfoNodeId,
			UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
			UA_QUALIFIEDNAME(1, "Set_Carrier_sense"),
			uaAttrMethod, &OpcSerCallbackSetCarrierSense,
			1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
	}


	// Get_Msr method node
	UA_Argument_init(&uaArgumentOutput[0]);
	uaArgumentOutput[0].description = UA_LOCALIZEDTEXT("en-US", "CTS state");
	uaArgumentOutput[0].name = UA_STRING("CTS state");
	uaArgumentOutput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentOutput[0].valueRank = -1;

	UA_Argument_init(&uaArgumentOutput[1]);
	uaArgumentOutput[1].description = UA_LOCALIZEDTEXT("en-US", "DSR state");
	uaArgumentOutput[1].name = UA_STRING("DSR state");
	uaArgumentOutput[1].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentOutput[1].valueRank = -1;

	UA_Argument_init(&uaArgumentOutput[2]);
	uaArgumentOutput[2].description = UA_LOCALIZEDTEXT("en-US", "RI state");
	uaArgumentOutput[2].name = UA_STRING("RI state");
	uaArgumentOutput[2].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentOutput[2].valueRank = -1;

	UA_Argument_init(&uaArgumentOutput[3]);
	uaArgumentOutput[3].description = UA_LOCALIZEDTEXT("en-US", "DCD state");
	uaArgumentOutput[3].name = UA_STRING("DCD state");
	uaArgumentOutput[3].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
	uaArgumentOutput[3].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Get_Msr");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Get_Msr", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Get_Msr"),
		uaAttrMethod, &OpcSerCallbackGetMsr,
		0, NULL, 4, uaArgumentOutput, (void *)pDib, NULL);


	// Clear_serial_read_data method node
	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Clear_serial_read_data");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Clear_serial_read_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Clear_serial_read_data"),
		uaAttrMethod, &OpcSerCallbackClearSerialReadData,
		0, NULL, 0, NULL, (void *)pDib, NULL);


	// Clear_lsr_err method node
	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Clear_lsr_err");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Clear_lsr_err", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Clear_lsr_err"),
		uaAttrMethod, &OpcSerCallbackClearLsrError,
		0, NULL, 0, NULL, (void *)pDib, NULL);


	// Serial_write_data method node
	UA_Argument_init(&uaArgumentInput[0]);
	uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Data");
	uaArgumentInput[0].name = UA_STRING("Data");
	uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_STRING].typeId;
	uaArgumentInput[0].valueRank = -1;

	uaAttrMethod = UA_MethodAttributes_default;
	uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Serial_write_data");
	uaAttrMethod.executable = true;
	uaAttrMethod.userExecutable = true;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_write_data", pSDp->DpInfo.Mac[3], pSDp->DpInfo.Mac[4], pSDp->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
		pDib->SerUaObjectInfoNodeId,
		UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
		UA_QUALIFIEDNAME(1, "Serial_write_data"),
		uaAttrMethod, &OpcSerCallbackWriteData,
		1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerDeleteInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	)
{
	bool						bReturn = false;

	UA_NodeId					uaIdObjInfo = UA_NODEID_NULL;


	bReturn = LibSerClose(pSDp->DpInfo.Mac, pDib->Info.ChlNumber);
	if (bReturn != true)
	{

	}

	// Object info object node
	UA_Server_deleteNode(pService->uaServerPtr, pDib->SerUaObjectInfoNodeId, true);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetInterface(
	PSDP_DIB					pDib,
	unsigned char				OldModeCtrl
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Int32 					uaInt32;
	UA_Variant					uaVariant;
	UA_NodeId					uaIdNode = UA_NODEID_NULL;
	UA_MethodAttributes			uaAttrMethod;
	UA_VariableAttributes		uaAttrVariable;
	UA_Argument					uaArgumentInput[5];
	UA_Boolean					uaBoolean;


	if ((pDib->SerModeCtrl & 0x01) == 0x01)
	{
		uaInt32 = 1;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_interface", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


		// delete 422 node
		if ((pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01) && ((OldModeCtrl & 0x02) == 0x02))
		{
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);
		}
		// delete 485 node
		if ((pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01) && ((OldModeCtrl & 0x04) == 0x04))
		{
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);
		}
		// delete CS node
		if ((pDib->Info.SerInfo.CSCapability == 0x01) && ((OldModeCtrl & 0x04) == 0x04))
		{
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);
		}
	}
	else if ((pDib->SerModeCtrl & 0x02) == 0x02)
	{
		uaInt32 = 2;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_interface", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


		// delete 485 node
		if ((pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01) && ((OldModeCtrl & 0x04) == 0x04))
		{
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);
		}
		// delete CS node
		if ((pDib->Info.SerInfo.CSCapability == 0x01) && ((OldModeCtrl & 0x04) == 0x04))
		{
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);
		}
		// add 422 node
		if ((pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x02) == 0x02))
		{
			// Termination_422_ctrl variable node
			uaBoolean = ((pDib->SerModeCtrl & 0x20) == 0x20)?true:false;
			uaAttrVariable = UA_VariableAttributes_default;
			UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
			uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Termination_422_ctrl");
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

			UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				pDib->SerUaObjectInfoNodeId,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
				UA_QUALIFIEDNAME(1, "Termination_422_ctrl"),
				UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);

			// Set_termination_422_ctrl method node
			UA_Argument_init(&uaArgumentInput[0]);
			uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Termination RS422 ctrl");
			uaArgumentInput[0].name = UA_STRING("Termination RS422 ctrl");
			uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
			uaArgumentInput[0].valueRank = -1;

			uaAttrMethod = UA_MethodAttributes_default;
			uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_termination_422_ctrl");
			uaAttrMethod.executable = true;
			uaAttrMethod.userExecutable = true;

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

			UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				pDib->SerUaObjectInfoNodeId,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
				UA_QUALIFIEDNAME(1, "Set_termination_422_ctrl"),
				uaAttrMethod, &OpcSerCallbackSetTermination422Ctrl,
				1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
		}
	}
	else if ((pDib->SerModeCtrl & 0x04) == 0x04)
	{
		uaInt32 = 3;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_interface", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


		// delete 422 node
		if ((pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01) && ((OldModeCtrl & 0x02) == 0x02))
		{
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);
			uaIdNode = UA_NODEID_STRING(1, StringId);
			UA_Server_deleteNode(pService->uaServerPtr, uaIdNode, true);
		}
		// add 485 node
		if ((pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
		{
			// Termination_485_ctrl variable node
			uaBoolean = ((pDib->SerModeCtrl & 0x40) == 0x40)?true:false;
			uaAttrVariable = UA_VariableAttributes_default;
			UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
			uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Termination_485_ctrl");
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

			UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				pDib->SerUaObjectInfoNodeId,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
				UA_QUALIFIEDNAME(1, "Termination_485_ctrl"),
				UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);

			// Set_termination_485_ctrl method node
			UA_Argument_init(&uaArgumentInput[0]);
			uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Termination RS485 ctrl");
			uaArgumentInput[0].name = UA_STRING("Termination RS485 ctrl");
			uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
			uaArgumentInput[0].valueRank = -1;

			uaAttrMethod = UA_MethodAttributes_default;
			uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_termination_485_ctrl");
			uaAttrMethod.executable = true;
			uaAttrMethod.userExecutable = true;

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

			UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				pDib->SerUaObjectInfoNodeId,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
				UA_QUALIFIEDNAME(1, "Set_termination_485_ctrl"),
				uaAttrMethod, &OpcSerCallbackSetTermination485Ctrl,
				1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
		}
		// add CS node
		if ((pDib->Info.SerInfo.CSCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
		{
			// Carrier_sense variable node
			uaBoolean = ((pDib->SerModeCtrl & 0x10) == 0x10)?true:false;
			uaAttrVariable = UA_VariableAttributes_default;
			UA_Variant_setScalar(&uaAttrVariable.value, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
			uaAttrVariable.displayName = UA_LOCALIZEDTEXT("en-US", "Carrier_sense");
			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

			UA_Server_addVariableNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				pDib->SerUaObjectInfoNodeId,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASCOMPONENT),
				UA_QUALIFIEDNAME(1, "Carrier_sense"),
				UA_NODEID_NUMERIC(0, UA_NS0ID_BASEDATAVARIABLETYPE), uaAttrVariable, NULL, NULL);

			// Set_Carrier_sense method node
			UA_Argument_init(&uaArgumentInput[0]);
			uaArgumentInput[0].description = UA_LOCALIZEDTEXT("en-US", "Carrier sense");
			uaArgumentInput[0].name = UA_STRING("Carrier sense");
			uaArgumentInput[0].dataType = UA_TYPES[UA_TYPES_BOOLEAN].typeId;
			uaArgumentInput[0].valueRank = -1;

			uaAttrMethod = UA_MethodAttributes_default;
			uaAttrMethod.displayName = UA_LOCALIZEDTEXT("en-US", "Set_Carrier_sense");
			uaAttrMethod.executable = true;
			uaAttrMethod.userExecutable = true;

			memset(StringId, 0, sizeof(StringId));
			sprintf(StringId, "%02x:%02x:%02x-(%d)Set_Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

			UA_Server_addMethodNode(pService->uaServerPtr, UA_NODEID_STRING(1, StringId),
				pDib->SerUaObjectInfoNodeId,
				UA_NODEID_NUMERIC(0, UA_NS0ID_HASORDEREDCOMPONENT),
				UA_QUALIFIEDNAME(1, "Set_Carrier_sense"),
				uaAttrMethod, &OpcSerCallbackSetCarrierSense,
				1, uaArgumentInput, 0, NULL, (void *)pDib, NULL);
		}
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetParameter(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Int32					uaInt32;
	UA_Variant					uaVariant;


	// Baud_rate variable node
	switch (pDib->SerBaudrate)
	{
		case 0x00 : uaInt32 = 50; break;
		case 0x01 : uaInt32 = 75; break;
		case 0x02 : uaInt32 = 110; break;
		case 0x03 : uaInt32 = 134; break;
		case 0x04 : uaInt32 = 150; break;
		case 0x05 : uaInt32 = 300; break;
		case 0x06 : uaInt32 = 600; break;
		case 0x07 : uaInt32 = 1200; break;
		case 0x08 : uaInt32 = 2400; break;
		case 0x09 : uaInt32 = 4800; break;
		case 0x0a : uaInt32 = 9600; break;
		case 0x0b : uaInt32 = 19200; break;
		case 0x0c : uaInt32 = 38400; break;
		case 0x0d : uaInt32 = 57600; break;
		case 0x0e : uaInt32 = 115200; break;
		case 0x0f : uaInt32 = 230400; break;
		case 0x10 : uaInt32 = 460800; break;
		case 0x11 : uaInt32 = 921600; break;
		default : uaInt32 = 0; break;
	}
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Baud_rate", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	// Databits variable node
	switch (pDib->SerDatabit)
	{
		case 0x00 : uaInt32 = 5; break;	// 5
		case 0x01 : uaInt32 = 6; break;	// 6
		case 0x02 : uaInt32 = 7; break;	// 7
		case 0x03 : uaInt32 = 8; break;	// 8
		default : uaInt32 = 0; break;
	}
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Databits", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	// Parity variable node
	switch (pDib->SerParity)
	{
		case 0x00 : uaInt32 = 0; break;	// none
		case 0x01 : uaInt32 = 1; break;	// old
		case 0x02 : uaInt32 = 2; break;	// even
		case 0x03 : uaInt32 = 3; break;	// mark
		case 0x04 : uaInt32 = 4; break;	// space
		default : uaInt32 = 0; break;
	}
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Parity", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	// Stopbits variable node
	switch (pDib->SerStopbit)
	{
		case 0x00 : uaInt32 = 1; break;	// 1
		case 0x01 : uaInt32 = 3; break;	// 1.5
		case 0x02 : uaInt32 = 2; break;	// 2
		default : uaInt32 = 0; break;
	}
	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Stopbits", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetFlowCtrl(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Int32					uaInt32;
	UA_Variant					uaVariant;


	if (pDib->SerVersion <= 3)
	{
		switch (pDib->SerFlowctrl)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// RTS/CTS
			case 0x02 : uaInt32 = 2; break;	// DTR/DSR
			default : uaInt32 = 0; break;
		}
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Flowctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
	else
	{
		switch (pDib->SerOnChipHwFlowCtrl)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// RTS/CTS
			case 0x02 : uaInt32 = 2; break;	// DTR/DSR
			case 0x03 : uaInt32 = 3; break;	// both
			default : uaInt32 = 0; break;
		}
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Flowctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetDtr(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	uaBoolean = ((pDib->SerMcr & 0x02) == 0x02)?true:false;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Dtr", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetRts(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	uaBoolean = ((pDib->SerMcr & 0x01) == 0x01)?true:false;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Rts", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetBreak(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	uaBoolean = (pDib->SerBreak == 0x01)?true:false;


	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Break", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetTermination422Ctrl(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	if ((pDib->Info.SerInfo.RS422TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x02) == 0x02))
	{
		uaBoolean = ((pDib->SerModeCtrl & 0x20) == 0x20)?true:false;


		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_422_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetTermination485Ctrl(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	if ((pDib->Info.SerInfo.RS485TerminationCtlCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
	{
		uaBoolean = ((pDib->SerModeCtrl & 0x40) == 0x40)?true:false;


		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Termination_485_ctrl", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetRiPowerIO(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Int32					uaInt32;
	UA_Variant					uaVariant;


	if (pDib->Info.SerInfo.RIPowerIOCapability & 0x03)
	{
		switch (pDib->SerPowerIO & 0x03)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// 5v
			case 0x02 : uaInt32 = 2; break;	// 12v
			case 0x03 : uaInt32 = 3; break;	// no distinguish
			default : uaInt32 = 0; break;
		}
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)RI_powerio", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}

}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetDcdPowerIO(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Int32					uaInt32;
	UA_Variant					uaVariant;


	if (pDib->Info.SerInfo.DCDPowerIOCapability & 0x03)
	{
		switch ((pDib->SerPowerIO & 0x0c) >> 2)
		{
			case 0x00 : uaInt32 = 0; break;	// none
			case 0x01 : uaInt32 = 1; break;	// 5v
			case 0x02 : uaInt32 = 2; break;	// 12v
			case 0x03 : uaInt32 = 3; break;	// no distinguish
			default : uaInt32 = 0; break;
		}
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)DCD_powerio", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaInt32, &UA_TYPES[UA_TYPES_INT32]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}

}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateSetCarrierSense(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	if ((pDib->Info.SerInfo.CSCapability == 0x01) && ((pDib->SerModeCtrl & 0x04) == 0x04))
	{
		uaBoolean = ((pDib->SerModeCtrl & 0x10) == 0x10)?true:false;


		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Carrier_sense", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateMsrEvent(
	PSDP_DIB					pDib
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	// Msr_cts
	uaBoolean = ((pDib->SerMsr & 0x01) == 0x01)?true:false;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_cts", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	// Msr_dsr
	uaBoolean = ((pDib->SerMsr & 0x02) == 0x02)?true:false;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_dsr", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	// Msr_dcd
	uaBoolean = ((pDib->SerMsr & 0x08) == 0x08)?true:false;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_dcd", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


	// Msr_ri
	uaBoolean = ((pDib->SerMsr & 0x04) == 0x04)?true:false;

	memset(StringId, 0, sizeof(StringId));
	sprintf(StringId, "%02x:%02x:%02x-(%d)Msr_ri", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

	UA_Variant_init(&uaVariant);
	UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
	UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateLsrEvent(
	PSDP_DIB					pDib
	)
{

}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
OpcSerUpdateDataEvent(
	PSDP_DIB					pDib,
	unsigned char *				pData,
	unsigned int				DataLength
	)
{
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean = false;
	UA_String					uaString;
	UA_Variant					uaVariant;
	unsigned char *				pRawData = NULL;
	int							i = 0;
	int							RawDataLength = 0;


	do
	{
		pRawData = (unsigned char *)malloc(DataLength);
		if (pRawData == NULL)
		{
			break;
		}
		memset(pRawData, 0, DataLength);


		for (i = 0; i < DataLength; i+=2)
		{
			if ((*(pData + i + 1) & 0x08) == 0x08)
			{
				pRawData[RawDataLength] = *(pData + i);
				RawDataLength++;
			}

			if (((*(pData + i + 1) & 0x01) == 0x01) && (pDib->SerLsrFrameErrorState == 0x00))
			{
				//printf("OPC (:%.2x:%.2x:%.2x), frame ERROR !!!!!\n", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5]);

				pDib->SerLsrFrameErrorState = 0x01;

				uaBoolean = (pDib->SerLsrFrameErrorState == 0x01)?true:false;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_frame_err", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

				UA_Variant_init(&uaVariant);
				UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
			}

			if (((*(pData + i + 1) & 0x02) == 0x02) && (pDib->SerLsrParityErrorState == 0x00))
			{
				//printf("OPC (:%.2x:%.2x:%.2x), parity ERROR !!!!!\n", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5]);

				pDib->SerLsrParityErrorState = 0x01;

				uaBoolean = (pDib->SerLsrParityErrorState == 0x01)?true:false;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_parity_err", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

				UA_Variant_init(&uaVariant);
				UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
			}

			if (((*(pData + i + 1) & 0x04) == 0x04) && (pDib->SerLsrBreakErrorState == 0x00))
			{
				//printf("OPC (:%.2x:%.2x:%.2x), break ERROR !!!!!\n", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5]);

				pDib->SerLsrBreakErrorState = 0x01;

				uaBoolean = (pDib->SerLsrBreakErrorState == 0x01)?true:false;

				memset(StringId, 0, sizeof(StringId));
				sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_break_err", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

				UA_Variant_init(&uaVariant);
				UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
				UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);
			}
		}


		uaString = UA_STRING((char *)pRawData);
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_read_data", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaString, &UA_TYPES[UA_TYPES_STRING]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);

	} while (false);

	if (pRawData != NULL)
	{
		free(pRawData);
		pRawData = NULL;
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetInterface(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetInterface, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1);

	do
	{
		if ((uaValue1 < 1) || (uaValue1 > 3))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntSerSetInterface(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetParameters(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;
	UA_Int32					uaValue2 = *(UA_Int32 *)pInput[1].data;
	UA_Int32					uaValue3 = *(UA_Int32 *)pInput[2].data;
	UA_Int32					uaValue4 = *(UA_Int32 *)pInput[3].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetParameters, uaValue1:%d, uaValue2:%d, uaValue3:%d, uaValue4:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1, uaValue2, uaValue3, uaValue4);

	do
	{
		if ((uaValue1 != 50) && (uaValue1 != 75) && (uaValue1 != 110) && (uaValue1 != 134) && (uaValue1 != 150) && (uaValue1 != 300) &&
			(uaValue1 != 600) && (uaValue1 != 1200) && (uaValue1 != 1800) && (uaValue1 != 2400) && (uaValue1 != 4800) && (uaValue1 != 7200) &&
			(uaValue1 != 9600) && (uaValue1 != 19200) && (uaValue1 != 38400) && (uaValue1 != 57600) && (uaValue1 != 115200) &&
			(uaValue1 != 230400) && (uaValue1 != 460800) && (uaValue1 != 921600))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue2 < 5) || (uaValue2 > 8))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue3 < 0) || (uaValue3 > 4))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		if ((uaValue4 < 1) || (uaValue4 > 3))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntSerSetParameters(pDib, uaValue1, uaValue2, uaValue3, uaValue4);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetFlowctrl(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetFlowctrl, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 2))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntSerSetFlowctrl(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetDtr(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetDtr, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntSerSetDtr(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetRts(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetRts, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntSerSetRts(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetBreak(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetBreak, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntSerSetBreak(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetTermination422Ctrl(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetTermination422Ctrl, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntSerSetTermination422Ctrl(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetTermination485Ctrl(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetTermination485Ctrl, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntSerSetTermination485Ctrl(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetRiPowerIO(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetRiPowerIO, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 3))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntSerSetRiPowerIO(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetDcdPowerIO(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Int32					uaValue1 = *(UA_Int32 *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetDcdPowerIO, uaValue1:%d\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1);

	do
	{
		if ((uaValue1 < 0) || (uaValue1 > 3))
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		bReturn = IntSerSetDcdPowerIO(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackSetCarrierSense(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaValue1 = *(UA_Boolean *)pInput[0].data;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackSetCarrierSense, uaValue1:%s\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5], uaValue1?"true":"false");

	do
	{
		bReturn = IntSerSetCarrierSense(pDib, uaValue1);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackGetMsr(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_Boolean					uaBoolean;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackGetMsr\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);

	do
	{
		// cts
		uaBoolean = ((pDib->SerMsr & 0x01) == 0x01)?true:false;
		UA_Variant_setScalarCopy(&pOutput[0], &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

		// dsr
		uaBoolean = ((pDib->SerMsr & 0x02) == 0x02)?true:false;
		UA_Variant_setScalarCopy(&pOutput[1], &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

		// ri
		uaBoolean = ((pDib->SerMsr & 0x04) == 0x04)?true:false;
		UA_Variant_setScalarCopy(&pOutput[2], &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

		// dcd
		uaBoolean = ((pDib->SerMsr & 0x08) == 0x08)?true:false;
		UA_Variant_setScalarCopy(&pOutput[3], &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackClearSerialReadData(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_String					uaString = UA_STRING("");
	UA_Variant					uaVariant;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackClearSerialReadData\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);

	do
	{
		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Serial_read_data", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaString, &UA_TYPES[UA_TYPES_STRING]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackClearLsrError(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	POPC_SERVICE				pService = &OpcService;
	char						StringId[256] = {0};
	UA_Boolean					uaBoolean;
	UA_Variant					uaVariant;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackClearLsrError\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);

	do
	{
		// SerLsrFrameErrorState
		pDib->SerLsrFrameErrorState = 0x00;

		uaBoolean = (pDib->SerLsrFrameErrorState == 0x01)?true:false;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_frame_err", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


		// SerLsrParityErrorState
		pDib->SerLsrParityErrorState = 0x00;

		uaBoolean = (pDib->SerLsrParityErrorState == 0x01)?true:false;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_parity_err", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);


		// SerLsrBreakErrorState
		pDib->SerLsrBreakErrorState = 0x00;

		uaBoolean = (pDib->SerLsrBreakErrorState == 0x01)?true:false;

		memset(StringId, 0, sizeof(StringId));
		sprintf(StringId, "%02x:%02x:%02x-(%d)Lsr_break_err", pDib->SDpPtr->DpInfo.Mac[3], pDib->SDpPtr->DpInfo.Mac[4], pDib->SDpPtr->DpInfo.Mac[5], pDib->ObjIndex);

		UA_Variant_init(&uaVariant);
		UA_Variant_setScalar(&uaVariant, &uaBoolean, &UA_TYPES[UA_TYPES_BOOLEAN]);
		UA_Server_writeValue(pService->uaServerPtr, UA_NODEID_STRING(1, StringId), uaVariant);

	} while (false);

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


UA_StatusCode
OpcSerCallbackWriteData(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	)
{
	UA_StatusCode				uaStatus = UA_STATUSCODE_GOOD;
	bool						bReturn = false;
	PSDP_DIB					pDib = (PSDP_DIB)pMethodContext;
	PDP_INFO					pDpInfo = &pDib->SDpPtr->DpInfo;
	UA_String *					uaValue1Ptr = (UA_String *)pInput[0].data;
	unsigned char *				pData = NULL;
	unsigned int				DataLength = 0;


	//printf("OPC (:%.2x:%.2x:%.2x), OpcSerCallbackWriteData\n", pDpInfo->Mac[3], pDpInfo->Mac[4], pDpInfo->Mac[5]);

	do
	{
		DataLength = uaValue1Ptr->length;
		if (DataLength <= 0)
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}

		pData = (unsigned char *)malloc(DataLength);
		if (pData == NULL)
		{
			uaStatus = UA_STATUSCODE_UNCERTAINENGINEERINGUNITSEXCEEDED;
			break;
		}
		memset(pData, 0, DataLength);

		memcpy(pData, uaValue1Ptr->data, DataLength);


		bReturn = IntSerWriteData(pDib, pData, DataLength);
		if (bReturn != true)
		{
			uaStatus = UA_STATUSCODE_BADUNEXPECTEDERROR;
			break;
		}

	} while (false);

	if (pData != NULL)
	{
		free(pData);
		pData = NULL;
	}

	return uaStatus;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


