/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#ifndef _SDXOPCUA_PROG_SXXF_H_
#define _SDXOPCUA_PROG_SXXF_H_


// sxx_list.c
void
SxxListInit(
	DLIST *						pListHead
	);

bool
SxxListEmpty(
	DLIST *						pListHead
	);

DLIST *
SxxListGetNext(
	DLIST *						pListHead
	);

DLIST *
SxxListGetPrev(
	DLIST *						pListHead
	);

void
SxxListRemoveEntry(
	DLIST *						pEntry
	);

void
SxxListInsertEntry(
	DLIST *						pEntry,
	DLIST *						pNewEntry
	);

void
SxxListInsertHead(
	DLIST *						pListHead,
	DLIST *						pEntry
	);

void
SxxListInsertTail(
	DLIST *						pListHead,
	DLIST *						pEntry
	);


// sxx_utils.c
char
SxxGetche(
	void
	);


// log_openclose.c
bool
LogOpen(
	void
	);

void
LogClose(
	void
	);


// log_tx.c
bool
LogTx(
	char *						pStr,
	int							Length
	);


// lib_service.c
bool
LibServiceStart(
	PLIB_SERVICE				pService
	);

void
LibServiceStop(
	PLIB_SERVICE				pService
	);


// lib_mng.c
bool
LibMngInit(
	void
	);

void
LibMngFree(
	void
	);

bool
LibMngGetServiceStatus(
	void
	);

bool
LibMngGetAllNicInfo(
	PNIC_LIST					pList
	);

bool
LibMngRefreshNic(
	PNIC_LIST					pList
	);

bool
LibMngGetVersionInfo(
	PVERSION_INFO				pInfo
	);

bool
LibMngSearchDp(
	PDP_LIST					pList
	);

bool
LibMngGetSpecificDpDetailInfo(
	unsigned char *				pMac,
	PDP_INFO					pInfo
	);

bool
LibMngConnect(
	unsigned char *				pMac,
	unsigned int				PassWdSetting,
	unsigned char *				pPassWd,
	unsigned int				PassWdLength,
	int *						pSioTcpPort,
	int *						pCtuTcpPort
	);

bool
LibMngDisconnect(
	unsigned char *				pMac
	);

bool
LibMngMapping(
	unsigned char *				pMac
	);

bool
LibMngUnMapping(
	unsigned char *				pMac
	);

bool
LibMngGetAllDpMappingInfo(
	PDP_MAPPING_LIST			pList
	);

bool
LibMngGetAllDpConnectedInfo(
	PDP_LIST					pList
	);

bool
LibMngGetPassword(
	unsigned char *				pMac,
	unsigned char *				pPassword,
	unsigned int *				pPasswordLength
	);

bool
LibMngSetDisconnectEventCallback(
	unsigned char *				pMac
	);


// lib_ctu.c
bool
LibCtuConnect(
	unsigned char *				pMac
	);

bool
LibCtuDisconnect(
	unsigned char *				pMac
	);

bool
LibCtuSetMac(
	unsigned char *				pMac,
	unsigned char *				pNewMac
	);

bool
LibCtuSetDeviceName(
	unsigned char *				pMac,
	unsigned char *				pDeviceName
	);

bool
LibCtuSetPassword(
	unsigned char *				pMac,
	unsigned char 				PwdSetting,
	unsigned char *				pPwdData
	);

bool
LibCtuStoreUartSetting(
	unsigned char *				pMac
	);

bool
LibCtuStoreDioSetting(
	unsigned char *				pMac
	);


// lib_sio.c
bool
LibSioConnect(
	unsigned char *				pMac,
	int							SioTcpPort
	);

bool
LibSioDisconnect(
	unsigned char *				pMac
	);

bool
LibSioGetConnection(
	unsigned char *				pMac
	);


// lib_ser.c
bool
LibSerOpen(
	unsigned char *				pMac,
	int							DibChlNumber,
	PSER_STATE_INFO				pState
	);

bool
LibSerClose(
	unsigned char *				pMac,
	int							DibChlNumber
	);

bool
LibSerSetFifoCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				FifoCtrl
	);

bool
LibSerSetMcr(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Mcr
	);

bool
LibSerSetEventCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				EventCtrl
	);

bool
LibSerSetPowerIO(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Mode
	);

bool
LibSerSetModeCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Mode
	);

bool
LibSerWrite(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pData,
	unsigned int				DataLength
	);

bool
LibSerSetting(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Baudrate,
	unsigned char				Databit,
	unsigned char				Parity,
	unsigned char				Stopbit,
	unsigned char				Flowctrl
	);

bool
LibSerSetBreak(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				State
	);

bool
LibSerGetOnChipHwFlowCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pHwFlowctrl
	);

bool
LibSerSetOnChipHwFlowCtrl(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char 				HwFlowctrl
	);

bool
LibSerGetTxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pTriggerLevel
	);

bool
LibSerSetTxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char 				TriggerLevel
	);

bool
LibSerGetRxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pTriggerLevel
	);

bool
LibSerSetRxTriggerLevel(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char 				TriggerLevel
	);

bool
LibSerSetMsrEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	);

bool
LibSerSetLsrEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	);

bool
LibSerSetDataEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	);

bool
LibSerSetDataCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	);


// lib_dio.c
bool
LibDioGetInfo(
	unsigned char *				pMac,
	int							DibChlNumber,
	PDIO_INFO 					pDioInfo
	);

bool
LibDioGetBankState(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pBankState
	);

bool
LibDioGetBankInputInvert(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pBankInputInvert
	);

bool
LibDioGetBankDirection(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pBankDirection
	);

bool
LibDioGetBankInputEventMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char *				pBankInputEventMode
	);

bool
LibDioSetBankState(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				BankState
	);

bool
LibDioSetBankInputInvert(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				BankInputInvert
	);

bool
LibDioSetBankDirection(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				BankDirection
	);

bool
LibDioSetBankInputEventMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char 				BankInputEventMode
	);

bool
LibDioGetBankSamplingClock(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char *				pBankSamplingClock
	);

bool
LibDioGetBankOutputPinConfig(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char *				pBankOutputPinConfig
	);

bool
LibDioSetBankOutputPinConfig(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char 				BankOutputPinConfig
	);

bool
LibDioGetBankOutputInitialValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pInitialValue
	);

bool
LibDioSetBankOutputInitialValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				InitialValue
	);

bool
LibDioGetBankOutputSafeValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pSafeValue
	);

bool
LibDioSetBankOutputSafeValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				SafeValue
	);

bool
LibDioGetOutputSafeValueTimer(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char *				pSetting,
	unsigned char *				pSeconds
	);

bool
LibDioSetOutputSafeValueTimer(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Setting,
	unsigned char				Seconds
	);

bool
LibDioGetBankInputLatchRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pLatchEdge
	);

bool
LibDioSetBankInputLatchRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				LatchEdge
	);

bool
LibDioGetBankInputLatchFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pLatchEdge
	);

bool
LibDioSetBankInputLatchFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				LatchEdge
	);

bool
LibDioSetBankInputCounterReset(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				Value
	);

bool
LibDioGetBankInputCounterIncrementRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pValue
	);

bool
LibDioSetBankInputCounterIncrementRisingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				Value
	);

bool
LibDioGetBankInputCounterIncrementFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int *				pValue
	);

bool
LibDioSetBankInputCounterIncrementFallingEdge(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned int 				Value
	);

bool
LibDioGetBankIoInputCounterCounterValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex,
	unsigned char				BankIoIndex,
	unsigned int *				pValue
	);

bool
LibDioSetBankInputEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber,
	int 						BankIndex
	);


// lib_mai.c
bool
LibMAiGetInfo(
	unsigned char *				pMac,
	int							DibChlNumber,
	PMAI_INFO 					pMAiInfo
	);

bool
LibMAiSetSampleEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Value
	);

bool
LibMAiSetDataEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Value
	);

bool
LibMAiSetEventEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned char				Value
	);

bool
LibMAiGetPortsEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned short *			pValue
	);

bool
LibMAiSetPortsEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned short				Value
	);

bool
LibMAiSetCalibration(
	unsigned char *				pMac,
	int							DibChlNumber,
	unsigned short				Value
	);

bool
LibMAiSetPortAiMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetPortTriggerMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetPortUpperTriggerValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	double		 				Value
	);

bool
LibMAiSetPortLowerTriggerValue(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	double		 				Value
	);

bool
LibMAiGetPortLoggingMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char * 			pValue
	);

bool
LibMAiSetPortLoggingMode(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetType0InputType(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetType0InputSelect(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetType0PullupResistor(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetType0Gain(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetType0Filter(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned short 				Value
	);

bool
LibMAiSetType1InputType(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetType1InputSelect(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiGetType1PgaEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char *				pValue
	);

bool
LibMAiSetType1PgaEnable(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiGetType1Gain(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char *				pValue
	);

bool
LibMAiSetType1Gain(
	unsigned char *				pMac,
	int							DibChlNumber,
	int							PortChl,
	unsigned char 				Value
	);

bool
LibMAiSetEventCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	);

bool
LibMAiSetDataCallback(
	unsigned char *				pMac,
	int							DibChlNumber
	);


// opc_service.c
void
OpcServiceCreateBasicNodeAndMethod(
	POPC_SERVICE				pService
	);

void
OpcServiceDeleteBasicNodeAndMethod(
	POPC_SERVICE				pService
	);

void
OpcServiceChangeDpServiceStartUpState(
	POPC_SERVICE				pService,
	bool						State
	);


// opc_mng.c
void
OpcMngAddSDpForSearch(
	PSDP_DEVICE					pSDp
	);

void
OpcMngDelSDpForSearch(
	PSDP_DEVICE					pSDp
	);

void
OpcMngAddSDpForConnect(
	PSDP_DEVICE					pSDp
	);

void
OpcMngDelSDpForConnect(
	PSDP_DEVICE					pSDp
	);

void
OpcMngUpdateSDpDeviceName(
	PSDP_DEVICE					pSDp
	);

void
OpcMngUpdateSDpPassword(
	PSDP_DEVICE					pSDp
	);

UA_StatusCode
OpcMngCallbackSearchSDp(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMngCallbackSDpConnect(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMngCallbackSDpDisconnect(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMngCallbackSDpSetDeviceName(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMngCallbackSDpSetMac(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMngCallbackSDpSetPassword(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMngCallbackSDpClearPassword(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);


// opc_ser.c
void
OpcSerCreateCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjRoot
	);

void
OpcSerDeleteCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	);

void
OpcSerCreateInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjObj
	);

void
OpcSerDeleteInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetInterface(
	PSDP_DIB					pDib,
	unsigned char				OldModeCtrl
	);

void
OpcSerUpdateSetParameter(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetFlowCtrl(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetDtr(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetRts(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetBreak(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetTermination422Ctrl(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetTermination485Ctrl(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetRiPowerIO(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetDcdPowerIO(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateSetCarrierSense(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateMsrEvent(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateLsrEvent(
	PSDP_DIB					pDib
	);

void
OpcSerUpdateDataEvent(
	PSDP_DIB					pDib,
	unsigned char *				pData,
	unsigned int				DataLength
	);


UA_StatusCode
OpcSerCallbackSetInterface(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetParameters(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetFlowctrl(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetDtr(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetRts(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetBreak(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetTermination422Ctrl(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetTermination485Ctrl(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetRiPowerIO(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetDcdPowerIO(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackSetCarrierSense(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackGetMsr(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackClearSerialReadData(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackClearLsrError(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcSerCallbackWriteData(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);


// opc_dio.c
void
OpcDioCreateCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjRoot
	);

void
OpcDioDeleteCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	);

void
OpcDioCreateInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjObj
	);

void
OpcDioDeleteInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	);

void
OpcDioUpdateSetOutputTimerEnable(
	PSDP_DIB					pDib
	);

void
OpcDioUpdateSetOutputTimerTime(
	PSDP_DIB					pDib
	);

void
OpcDioUpdateSetBankDirection(
	PSDP_DIO_BANK				pDioBank
	);

void
OpcDioUpdateSetBankInputEventTriggerMode(
	PSDP_DIO_BANK				pDioBank
	);

void
OpcDioUpdateSetBankOutputPinMode(
	PSDP_DIO_BANK				pDioBank
	);

void
OpcDioUpdateSetPortOutputInitValue(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateSetPortOutputSaveValue(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateSetPortState(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateGetPortState(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateGetPortInputCounter(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateGetPortInputLatchRisingEdge(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateGetPortInputLatchFallingEdge(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateResetPortInputCounter(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateResetPortInputLatchRisingEdge(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateResetPortInputLatchFallingEdge(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateSetPortInputCounterIncrementRisingEdgeEnable(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateSetPortInputCounterIncrementFallingEdgeEnable(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateSetPortInputInvertEnable(
	PSDP_DIO_PORT				pDioPort
	);

void
OpcDioUpdateBankInputEvent(
	PSDP_DIO_BANK				pDioBank
	);

UA_StatusCode
OpcDioCallbackSetOutputSaveTimerEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetOutputSaveTimerTime(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetBankDirection(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetBankInputEventTriggerMode(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetBankOutputPinMode(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetPortOutputInitValue(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetPortOutputSaveValue(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetPortState(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackGetPortState(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackGetPortInputCounter(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackGetPortInputLatchRisingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackGetPortInputLatchFallingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackResetPortInputCounter(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackResetPortInputLatchRisingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackResetPortInputLatchFallingEdge(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetPortInputCounterIncrementRisingEdgeEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetPortInputCounterIncrementFallingEdgeEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcDioCallbackSetPortInputInvertEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);


// opc_mai.c
void
OpcMAiCreateCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjRoot
	);

void
OpcMAiDeleteCapaNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	);

void
OpcMAiCreateInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib,
	UA_NodeId *					pUaIdObjObj
	);

void
OpcMAiDeleteInfoNode(
	POPC_SERVICE				pService,
	PSDP_DEVICE					pSDp,
	PSDP_DIB					pDib
	);

void
OpcMAiUpdateReadData(
	PSDP_MAI_PORT				pMAiPort
	);

void
OpcMAiUpdateSetPortEnable(
	PSDP_MAI_PORT				pMAiPort
	);

void
OpcMAiUpdateSetMeasureMode(
	PSDP_MAI_PORT				pMAiPort
	);

void
OpcMAiUpdateSetTriggerRange(
	PSDP_MAI_PORT				pMAiPort
	);

void
OpcMAiUpdateSetDataReturnInterval(
	PSDP_MAI_PORT				pMAiPort
	);

UA_StatusCode
OpcMAiCallbackReadData(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMAiCallbackSetPortEnable(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMAiCallbackSetMeasureMode(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMAiCallbackSetTriggerRange(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);

UA_StatusCode
OpcMAiCallbackSetDataReturnInterval(
	UA_Server *					pServer,
	const UA_NodeId *			pSessionId,
	void *						pSessionHandle,
	const UA_NodeId *			pMethodId,
	void *						pMethodContext,
	const UA_NodeId *			pObjectId,
	void *						pObjectContext,
	size_t						inputSize,
	const UA_Variant *			pInput,
	size_t						outputSize,
	UA_Variant *				pOutput
	);


// opc_mai_thread.c
bool
OpcMAiThreadStart(
	PSDP_DIB					pDib
	);

void
OpcMAiThreadStop(
	PSDP_DIB					pDib
	);


// int_mng.c
bool
IntMngSearchSDp(
	void
	);

bool
IntMngSDpConnect(
	PSDP_DEVICE					pSDp,
	bool						PasswdEnable,
	char *						pPasswdData,
	int							PasswdDataLength
	);

bool
IntMngSDpDisconnect(
	PSDP_DEVICE					pSDp
	);

bool
IntMngSDpSetDeviceName(
	PSDP_DEVICE					pSDp,
	char *						pDeviceName
	);

bool
IntMngSDpSetDeviceMac(
	PSDP_DEVICE					pSDp,
	char *						pDeviceMac
	);

bool
IntMngSDpSetPassword(
	PSDP_DEVICE					pSDp,
	char *						pPasswdData,
	int							PasswdDataLength
	);

bool
IntMngSDpClearPassword(
	PSDP_DEVICE					pSDp
	);

void
LibMngDisconnectEventCallback(
	unsigned char *				pMac
	);

void
IntMngDisconnectEventCallback(
	unsigned char *				pMac
	);


// int_ser.c
bool
IntSerSetInterface(
	PSDP_DIB					pDib,
	unsigned int				Interface
	);

bool
IntSerSetParameters(
	PSDP_DIB					pDib,
	unsigned int				Baudrate,
	unsigned int				Databit,
	unsigned int				Parity,
	unsigned int				Stopbit
	);

bool
IntSerSetFlowctrl(
	PSDP_DIB					pDib,
	unsigned int				FlowCtrl
	);

bool
IntSerSetDtr(
	PSDP_DIB					pDib,
	bool						State
	);

bool
IntSerSetRts(
	PSDP_DIB					pDib,
	bool						State
	);

bool
IntSerSetBreak(
	PSDP_DIB					pDib,
	unsigned char				State
	);

bool
IntSerSetTermination422Ctrl(
	PSDP_DIB					pDib,
	bool						State
	);

bool
IntSerSetTermination485Ctrl(
	PSDP_DIB					pDib,
	bool						State
	);

bool
IntSerSetRiPowerIO(
	PSDP_DIB					pDib,
	unsigned int				PowerIO
	);

bool
IntSerSetDcdPowerIO(
	PSDP_DIB					pDib,
	unsigned int				PowerIO
	);

bool
IntSerSetCarrierSense(
	PSDP_DIB					pDib,
	bool						State
	);

bool
IntSerWriteData(
	PSDP_DIB					pDib,
	unsigned char *				pData,
	unsigned int				DataLength
	);

void
IntSerMsrEventCallback(
	unsigned char *				pMac,
	int							DibChl,
	unsigned char				Msr
	);

void
IntSerLsrEventCallback(
	unsigned char *				pMac,
	int							DibChl,
	unsigned char				Lsr,
	unsigned char				CreditBit8,
	unsigned char				Credit
	);

void
IntSerDataEventCallback(
	unsigned char *				pMac,
	int							DibChl,
	unsigned char *				pData,
	int							DataLength
	);


// int_dio.c
bool
IntDioSetOutputTimerEnable(
	PSDP_DIB					pDib,
	bool						Enable
	);

bool
IntDioSetOutputTimerTime(
	PSDP_DIB					pDib,
	double						Time
	);

bool
IntDioSetBankDirection(
	PSDP_DIO_BANK				pDioBank,
	unsigned int				Direction
	);

bool
IntDioSetBankInputEventTriggerMode(
	PSDP_DIO_BANK				pDioBank,
	unsigned char				InputEventMode
	);

bool
IntDioSetBankOutputPinMode(
	PSDP_DIO_BANK				pDioBank,
	unsigned char				OutputPinMode
	);

bool
IntDioSetPortOutputInitValue(
	PSDP_DIO_PORT				pDioPort,
	bool						State
	);

bool
IntDioSetPortOutputSaveValue(
	PSDP_DIO_PORT				pDioPort,
	bool						State
	);

bool
IntDioSetPortState(
	PSDP_DIO_PORT				pDioPort,
	bool						State
	);

bool
IntDioGetPortState(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioGetPortInputCounter(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioGetPortInputLatchRisingEdge(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioGetPortInputLatchFallingEdge(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioResetPortInputCounter(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioResetPortInputLatchRisingEdge(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioResetPortInputLatchFallingEdge(
	PSDP_DIO_PORT				pDioPort
	);

bool
IntDioSetPortInputCounterIncrementRisingEdgeEnable(
	PSDP_DIO_PORT				pDioPort,
	bool						State
	);

bool
IntDioSetPortInputCounterIncrementFallingEdgeEnable(
	PSDP_DIO_PORT				pDioPort,
	bool						State
	);

bool
IntDioSetPortInputInvertEnable(
	PSDP_DIO_PORT				pDioPort,
	bool						State
	);

void
IntDioBankInputEventCallback(
	unsigned char *				pMac,
	int							DibChl,
	int							BankIndex,
	unsigned int 				DeltaValue,
	unsigned int				InputValue
	);


// int_mai.c
bool
IntMAiReadData(
	PSDP_MAI_PORT				pMAiPort
	);

bool
IntMAiSetPortEnable(
	PSDP_MAI_PORT				pMAiPort,
	bool						PortEnable
	);

bool
IntMAiSetMeasureMode(
	PSDP_MAI_PORT				pMAiPort,
	unsigned int				MeasureMode,
	unsigned int				InputRange
	);

bool
IntMAiSetTriggerRange(
	PSDP_MAI_PORT				pMAiPort,
	bool						TriggerEnable,
	double						StartRange,
	double						EndRange
	);

bool
IntMAiSetDataReturnInterval(
	PSDP_MAI_PORT				pMAiPort,
	unsigned int				Interval
	);

void
IntMAiEventCallback(
	unsigned char *				pMac,
	int							DibChl,
	int							PortChl,
	unsigned char				Event,
	double						EventValue
	);

void
IntMAiDataCallback(
	unsigned char *				pMac,
	int							DibChl,
	int							PortChl,
	double						Data
	);


// sdp_main.c
int
SDpMainIndexAlloc(
	void
	);

void
SDpMainIndexFree(
	unsigned char				Index
	);

PSDP_DEVICE
SDpMainGetByMac(
	unsigned char *				pMac
	);

PSDP_DEVICE
SDpMainGetByIndex(
	unsigned char 				Index
	);

bool
SDpMainAdd(
	PDP_INFO					pDpInfo,
	bool						IsConnectedByHost,
	unsigned char *				pPassword,
	unsigned int				PasswordLength
	);

void
SDpMainDelAllWithoutConnectedByHost(
	void
	);

void
SDpMainDelAll(
	void
	);


#endif


