/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#ifndef _SDXOPCUA_PROG_SXXG_H_
#define _SDXOPCUA_PROG_SXXG_H_


/**********************************************************************/


#define OBJ_NAME						"sdxopcua"
#define OBJ_VERSION						"1.0.0.0"
#define BUILD_FOR_DAEMON				1


/**********************************************************************/


#ifdef	bool
#undef	bool
#define bool                            int
#else
#define bool                            int
#endif

#ifdef	true
#undef	true
#define	true                            1
#else
#define	true                            1
#endif

#ifdef	false
#undef	false
#define	false                           0
#else
#define	false                           0
#endif


#ifndef INVALID_SOCKET
#define INVALID_SOCKET					-1
#endif

#ifndef INVALID_HANDLE
#define INVALID_HANDLE					-1
#endif


/**********************************************************************/


typedef struct _DLIST
{
	struct _DLIST *				Flink;
	struct _DLIST *				Blink;

} DLIST;


/**********************************************************************/


#define BUFF_SIZE							8192
#define CONTI_RXTX_CNT						1024


/**********************************************************************/


#define LOG_FILENAME						"/var/log/sdxopcua.log"


/**********************************************************************/


#define SDP_INDEX_NUMBER_MAX				256
#define SDP_DIB_MAX							64


typedef struct _SDP_DIO_BANK *PSDP_DIO_BANK;
typedef struct _SDP_DIB *PSDP_DIB;
typedef struct _SDP_DEVICE *PSDP_DEVICE;


typedef struct _SDP_DIO_PORT
{
	unsigned int				PortIndex;

	PSDP_DEVICE					SDpPtr;
	PSDP_DIO_BANK				BankPtr;

	unsigned int				InputCounterValue;

} SDP_DIO_PORT, *PSDP_DIO_PORT;

typedef struct _SDP_DIO_BANK
{
	unsigned int				BankIndex;
	PSDP_DEVICE					SDpPtr;
	PSDP_DIB					DibPtr;
	PBANK_INFO					BankInfoPtr;

	unsigned int				IoMask;

	unsigned int				Direction;
	unsigned int				State;
	unsigned int				DeltaState;
	unsigned char				InputEventMode;
	unsigned int				InputInvert;
	unsigned int				InputLatchRisingEdge;
	unsigned int				InputLatchFallingEdge;
	unsigned int				InputCounterIncrementRisingEdge;
	unsigned int				InputCounterIncrementFallingEdge;

	unsigned char				OutputPinMode;
	unsigned int				OutputInitValue;
	unsigned int				OutputSafeValue;

	SDP_DIO_PORT				Port[32];

} SDP_DIO_BANK, *PSDP_DIO_BANK;


typedef struct _SDP_MAI_PORT
{
	unsigned int				PortIndex;

	PSDP_DEVICE					SDpPtr;
	PSDP_DIB					DibPtr;
	unsigned char				PortEnable;
	double						CurrentData;
	unsigned int				MeasureMode;
	unsigned char				TriggerEnable;
	double						UpperTriggerValue;
	double						LowerTriggerValue;
	unsigned int				ADCCtrlReg;

	unsigned int				DataReturnInterval;
	unsigned int				DataReturnIntervalCnt;

} SDP_MAI_PORT, *PSDP_MAI_PORT;


typedef struct _SDP_DIB
{
	//---------------------------------------------------------
	DIB_INFO					Info;
	//---------------------------------------------------------
	unsigned int				ObjIndex;
	PSDP_DEVICE					SDpPtr;
	// SER
	UA_NodeId					SerUaObjectInfoNodeId;
	unsigned char				SerBaudrate;
	unsigned char				SerDatabit;
	unsigned char				SerParity;
	unsigned char				SerStopbit;
	unsigned char				SerFlowctrl;
	unsigned char				SerBreak;
	unsigned char				SerLsrFrameErrorState;
	unsigned char				SerLsrParityErrorState;
	unsigned char				SerLsrBreakErrorState;
	unsigned char				SerVersion;
	unsigned char				SerMcr;
	unsigned char				SerEventCtrl;
	unsigned char				SerOnChipHwFlowCtrl;
	unsigned char				SerMsr;
	unsigned char				SerTxTriggerLevel;
	unsigned char				SerRxTriggerLevel;
	unsigned char				SerPowerIO;
	unsigned char				SerModeCtrl;
	// DIO
	SDP_DIO_BANK				DioBank[32];
	unsigned char				DioSaveTimerEnable;
	unsigned char				DioSaveTimerTime;
	// MAI
	SDP_MAI_PORT				MAiPort[16];
	unsigned short				MAiPortsEnable;
	double						MAiVref;
	pthread_t					MAiThreadHd;
	pthread_cond_t				MAiThreadCondExit;
	pthread_mutex_t				MAiThreadMutex;
	pthread_attr_t				MAiThreadAttr;

} SDP_DIB, *PSDP_DIB;


typedef struct _SDP_DEVICE
{
	DLIST						Entry;
	unsigned char				Index;
	//---------------------------------------------------------
	DP_INFO						DpInfo;
	bool						HasDeviceName;
	unsigned char				DeviceName[64];
	bool						IsConnectedByHost;
	unsigned char				Password[128];
	unsigned int				PasswordLength;
	//---------------------------------------------------------

	SDP_DIB						DibArray[SDP_DIB_MAX];

} SDP_DEVICE, *PSDP_DEVICE;


/**********************************************************************/


typedef struct _SIO_CLIENT
{
	int							Sock;
	struct sockaddr_in			ServerAddr;

	bool						RxThreadStartup;

	unsigned char *				RxBuff;
	unsigned char *				TxBuff;

	pthread_cond_t				CmdCompleteCond;
	pthread_mutex_t				CmdCompleteMutex;

	int							RxThreadExitFd;
	pthread_t					RxThreadHd;
	pthread_attr_t				RxThreadAttr;

} SIO_CLIENT, *PSIO_CLIENT;


typedef struct _LIB_SERVICE
{
	
	pthread_t					ThreadHd;
	pthread_cond_t				ThreadCondExit;
	pthread_mutex_t				ThreadMutex;
	pthread_attr_t				ThreadAttr;

} LIB_SERVICE, *PLIB_SERVICE;


/**********************************************************************/


typedef struct _OPC_SERVICE
{
	UA_Boolean					uaIsRunning;

	UA_ServerConfig	*			uaServerConfigPtr;
	UA_Server *					uaServerPtr;

	pthread_t					ThreadHd;
	pthread_cond_t				ThreadCondExit;
	pthread_mutex_t				ThreadMutex;
	pthread_attr_t				ThreadAttr;

} OPC_SERVICE, *POPC_SERVICE;


#define OPC_NODEID_DPROOT				50000
#define OPC_NODEID_SERVICESTARTUP		50001
#define OPC_NODEID_DPSEARCH				50002
#define OPC_NODEID_DPSEARCHLIST			50003
#define OPC_NODEID_DPCONNECTLIST		50004


/**********************************************************************/


#define	UAID_Device_port				"Device_port"
#define	UAID_Service_start_up			"Service_start_up"
#define	UAID_Search_available_device	"Search_available_device"
#define	UAID_Search_device_list			"Search_device_list"
#define	UAID_Connect_device_list		"Connect_device_list"


/**********************************************************************/


extern pthread_mutex_t					DbgLock;
extern bool								DbgMngIpcProtocol;
extern bool								DbgSioIpcProtocol;
extern bool								PrintfEnable;
extern bool								LogEnable;
extern FILE *							LogNode;
extern char *							LogBuff;

extern bool								SDpIndexActive[SDP_INDEX_NUMBER_MAX];
extern pthread_mutex_t					SDpIndexActiveMutex;
extern int								SDpAmount;
extern DLIST							SDpList;
extern pthread_mutex_t					SDpListMutex;

extern bool								SDpServiceIsStartUp;

extern LIB_SERVICE						LibService;
extern OPC_SERVICE						OpcService;


/**********************************************************************/


#define STRUCT_BASE_POINTER(Fieldptr, Type, Field) \
	((Type *)(((char *)(Fieldptr)) - ((char *)(&(((Type *)0)->Field)))))

#define SDP_DEVICE_PTR(ListEntry) \
	STRUCT_BASE_POINTER(ListEntry, SDP_DEVICE, Entry)


/**********************************************************************/


#ifndef SOL_TCP
#define SOL_TCP							6
#endif


/**********************************************************************/


#define DLLP_CHL_TYPE_CONTROL_UNIT				0x00
#define DLLP_CHL_TYPE_UART						0x01
#define DLLP_CHL_TYPE_PARALLEL_PORT				0x02
#define DLLP_CHL_TYPE_DIO						0x03
#define DLLP_CHL_TYPE_COUNTER					0x04
#define DLLP_CHL_TYPE_AI						0x05
#define DLLP_CHL_TYPE_AO						0x06
#define DLLP_CHL_TYPE_UI						0x07
#define DLLP_CHL_TYPE_UO						0x08
#define DLLP_CHL_TYPE_BIPOLAR_AO				0x09
#define DLLP_CHL_TYPE_MULTIFUNC_AI				0x0a
#define DLLP_CHL_TYPE_TEMPERATURE_SENSOR		0x0b
#define DLLP_CHL_TYPE_VIRTUAL					0x80


/**********************************************************************/


#endif


